/* 
	GEDI-ADMX (c)
	Distributed under GNU General Public Licence
*/
#if defined(_WIN32) || defined(_WIN64)
#define snprintf _snprintf
	#if defined(_MSC_VER)
		#if _MSC_VER < 1500
			#define vsnprintf _vsnprintf
		#endif	
	#endif
#define strcasecmp _stricmp
#define strncasecmp _strnicmp
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <time.h>
#include <iostream>
using namespace std;
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "hmm_phase.h"
#include "random.h"
//#include "unixtimer.h"
#define MAJOR_EM_PROB 0.9
#define ADD_NOISE 1

#include<stdio.h>
#include<string.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>
#include <fstream>
int iSNPRemoved;
bool fixMIs;
bool bClean;
int half_overlap;
int mainGEDIFront(int argc, char** argv);
int mainGEDI();
char dummyStr1[1000];
char dummyStr2[1000];
char dummyStr3[1000];
char dummyStr4[1000];
char dummyStr5[1000];
char dummyStr6[1000];
char dummyStr7[1000];
char dummyStr8[1000];
char dummyStr9[1000];
char dummyStr10[1000];
int iPassNo; //Pass # coming from core output
char sFinal_SNP_FileName [100];
char * final_Output_file_name;
FILE * fSampleMapping;
char cA0;
char cA1;
char p1A0;
char p1A1;
char p2A0;
char p2A1;
double p_0;
double p_1;
int iCurrSNP; 
int iCurrSample;
char currAllele1;
char currAllele2;
char orgGen;
char predGen;
char a0;
char a1;
double q;
int iFront;
int highestSampleNo;
int sampleCount;
int currSampleNo;

bool bSpecialPhase;
double founder_bias;
double noise;
int max_steps;
int blocksize;
int totalSNPSize;
int nr_gen_to_estimate;	
char** gen_to_est_array;		//for single genotype input
char** gen_to_est_array_full;	//for blocking
int* gen_indiv_id;		//ID of individual (i.e. name of individual)
int hmmCount; //Number of Ancestors/HMMs in the hmmArray
bool bOutputProb; //Output imputation probabilities
void setMissingIndicators();
int currKSNPGlobal; //This is the absolute current index of the "K" snp (untyped SNP locus)
int getNextKLoc();
void setKData();
void freeKData();
bool bISFULLIMP; //where all genotypes are meant to be imputed
bool hasPartialMissingData;
bool* snp_missing_full;	//For indicating which SNPs have completely untyped values
bool* snp_missing_partial;	//For indicating which SNPs have some untyped values
bool* snp_typed_full;	//For indicating which SNPs have completely untyped values
bool* snp_typed_partial;	//For indicating which SNPs have some untyped values
int flanking;  //User defined input to fix the length of the HMM around k-length sequences of known genotypes
bool isFullMissingSNP(int iSNPIndex);
int currKSNPLocal; //This is the index of k in the local string (typically flanking-1)
bool bDoesEDC;
bool bDoesMDR;
bool bDoesIMP;
void freeMissingIndicators();
double **** ap_0; //4-D of 0 probabilities: [hmm1][hmm2][sample][snp]
double **** ap_1; //4-D of 1 probabilities: [hmm1][hmm2][sample][snp]
double **** ap_2; //4-D of 2 probabilities: [hmm1][hmm2][sample][snp]
int **true_gen; // 2-D of genotype values from input [sample][snp]
bool bHas_imp_snp;
int **anc1_call;
int **anc2_call;
int startLocGlobal;
int endLocGlobal;
int getGlobalSNP(int localSNP);
int getNearestTypedDistanceBefore(int baseLocGlobal);// scan back to find the distance to the nearest typed SNP before baseSNP
int getNearestTypedLocBefore(int baseLocGlobal);// scan back to find the distance to the nearest typed SNP before baseSNP
int getNearestTypedDistanceAfter(int baseLocGlobal);// scan back to find the distance to the nearest typed SNP before baseSNP
int getNearestTypedLocAfter(int baseLocGlobal);
void outputAncestryInference();
int getEndLocGlobal();//scans for non-imputed snps from startLoc up to a total of blocksize non-imputed snps
void outputEDC();
double llrt; 
void outputMDR();
void outputIMP();

typedef struct ANC_HMM //Used to describe the id of an ancestor, and it's corresponding HMM
{
	char name[20];
	int nr_genANC; //Count of haplotypes used to train HMM
	char** hap_array_ANC; //Block-based hap_array
	char** hap_array_full_ANC; //Full hap_array
	HAP_HMM hmm;
}ANC_HMM;
ANC_HMM * anc_map;

int getAncIndex(char ancName[20])
{
	int retVal = -1;
	for(int i = 0; i < hmmCount; i++)
	{
		if((strcasecmp(anc_map[i].name, ancName)==0)) return i;
	}
	return retVal;
}


typedef struct PED{
	char id[20];
	char fid[20];
	char mid[20];
	bool to_remove;
	int index_in_ped;
}PED;
PED *ped_map;

typedef struct SNP{
        char id[20];
        int chr;
        int pos;
        char a0;
        char a1;
        int pos_in_gen;
        bool failed_hwe_test;
        bool isHSNP; //Hapmap SNPs
        bool isWSNP; //WTCCC SNPs, or SNPs that we have genotype data for
        bool isISNP; //SNPs we want to impute
        bool isXSNP; //SNPs we want to exclude from any imputation
        char ia0; //the imputation version of allele 0- sometimes the signal is different
        char ia1; //the imputation version of allele 1- sometimes the signal is different
        double p;
        bool reversed; //If there is a negative sign, it was reversed;
        int a0HapCount; //Observed 0-allele counts in Haplotype Data
        int a0GenCount; //Observed 0-allele counts in Genotype Data
        int a1HapCount; //Observed 1-allele counts in Haplotype Data
        int a1GenCount; //Observed 1-allele counts in Genotype Data
        int obs_hets; //Observed Heterozygotes
        int obs_hom0; //Observed 0-Homozygotes
        int obs_hom1; //Observed 1-Homozygotes
        double a0HapFreq;
        double a1HapFreq;
        double a0GenFreq;
        double a1GenFreq;
        double hweVal;
        bool freqFlip; //If the frequencies of the hapmap alleles and genotype-count based alleles look flipped, we set this to true
} SNP;
SNP *snp_map;
static int comp_snp_id(const void *m1, const void *m2) 
{
            SNP *mi1 = (SNP *) m1;
            SNP  *mi2 = (SNP *) m2;
            return strcmp(mi1->id, mi2->id);
}
static int comp_ped_map_gen_id(const void *m1, const void *m2) 
{
            PED *mi1 = (PED *) m1;
            PED  *mi2 = (PED *) m2;
            return strcmp(mi1->id, mi2->id);
}

static int comp_ped_map_pos(const void *m1, const void *m2)
{
            PED *mi1 = (PED *) m1;
            PED  *mi2 = (PED *) m2;
            return (mi1->index_in_ped - mi2->index_in_ped);
}


static int comp_snp_pos(const void *m1, const void *m2) 
{
    SNP *mi1 = (SNP *) m1;
    SNP  *mi2 = (SNP *) m2;
	if(mi1->chr > mi2->chr)
		return 1;
	else
	if(mi1->chr < mi2->chr)
		return -1;
        else
	if( mi1->pos > mi2->pos)
		return 1;
	else
	if( mi1->pos < mi2->pos)
		return -1;
	else
	return 0;
}

int bin_search_snp_id(char *snp_id,int start, int end)
{
	if(end<start) return -1;
	int pp = start+(end-start)/2;
	int kk = strcmp(snp_id,snp_map[pp].id);
	if(kk==0) return pp;
	else
	if(kk<0) return bin_search_snp_id(snp_id,start,pp-1);
	else
	if(kk>0) return bin_search_snp_id(snp_id,pp+1,end);
	return -1;
}
int bin_search_gen_id(char *gen_id,int start, int end)
{
	if(end<start) return -1;
	int pp = start+(int)(end-start)/2;
	int kk = strcmp(gen_id, ped_map[pp].id);
	
	if(kk==0) return pp;
	else
	if(kk<0) return bin_search_gen_id(gen_id,start,pp-1);
	else
	if(kk>0) return bin_search_gen_id(gen_id,pp+1,end);
	return -1;
}
int nr_hsnp;
int nr_samples;
int nr_err; 
int main(int argc, char** argv)
{
	flanking = 100;
	blocksize = 200;
	half_overlap = 24;
	init_rand(1);
	founder_bias = .9;
	noise = .4;
	max_steps = 1000;
	nr_founders = 13;
	bSpecialPhase = false;
	bClean = true;
	bDoesEDC = false;
	llrt = 3.0;
	bDoesMDR = false;
	bDoesIMP = false;
	int chr;
	char * sGenFile;
	char ** argvFrontInputIMP;//second step, if imputation is done
	int tracker = 0;
	int badparam = false; 
	bOutputProb = false;
	argvFrontInputIMP = (char**)malloc(12*sizeof(char*));
	for(int j = 0; j < 12;j++)
	{        
		argvFrontInputIMP[j] = "";
	}
	final_Output_file_name = "Final.Output";
	bool bHas_ref_snp_info = false;
	bool bHas_pop_snp_info = false;
	bool bHas_ref_chr_hap = false;
	bool bHas_pop_ped = false;
	bool bHas_pop_chr_gen = false;
	bHas_imp_snp = false;
	bool bHas_anc_map = false;
	for(int i = 1; i < argc; i++)
	{			
		if(strcasecmp(argv[i],"-v")==0) //Verbose- Leaves intermediate files
		{
			bClean = false;
		}
		else if (strcasecmp(argv[i], "-EDC") == 0)
			bDoesEDC = true;
		else if(strcasecmp(argv[i],"-LLRT")==0)
			llrt = atof(argv[++i]);
		else if (strcasecmp(argv[i], "-MDR") == 0)
			bDoesMDR = true;
		else if (strcasecmp(argv[i], "-IMP") == 0)
		{
			argvFrontInputIMP[10] = argv[++i];
			bHas_imp_snp = true;
			bDoesIMP = true;
		}
		else if (strcasecmp(argv[i], "-blocksize")==0)
			blocksize = atoi(argv[++i]);
		else if (strcasecmp(argv[i], "-half_overlap")==0)
			half_overlap = atoi(argv[++i])*2;
		else if(strcasecmp(argv[i],"-chr")==0)
		{
			argvFrontInputIMP[9] = argv[++i];
			chr = atoi(argv[i]);
		}
		else if (strcasecmp(argv[i],"-ref_snp_info")==0)
		{
			argvFrontInputIMP[2] = argv[++i];
			bHas_ref_snp_info = true;
		}
		else if (strcasecmp(argv[i],"-pop_snp_info")==0)
		{
			argvFrontInputIMP[3] = argv[++i];
			bHas_pop_snp_info = true;
		}
		else if (strcasecmp(argv[i],"-ref_chr_hap")==0)
		{
			argvFrontInputIMP[8] = argv[++i];
			bHas_ref_chr_hap = true;
		}
		else if (strcasecmp(argv[i],"-pop_ped")==0)
		{
			argvFrontInputIMP[4] = argv[++i];
			bHas_pop_ped = true;
		}
		else if (strcasecmp(argv[i],"-pop_chr_gen")==0)
		{
			argvFrontInputIMP[1] = argv[++i];
			bHas_pop_chr_gen = true;
			sGenFile = argv[i];
		}
		else if (strcasecmp(argv[i],"-excl_sample")==0)
		{
			argvFrontInputIMP[5] = argv[++i];
		}
		else if (strcasecmp(argv[i],"-excl_snp")==0)
		{
			argvFrontInputIMP[6] = argv[++i];
		}
		else if (strcasecmp(argv[i],"-output_file_name")==0)
		{
			final_Output_file_name = argv[++i];
		}
		//GEDI parms:
		else if(strcasecmp(argv[i],"-nr_founders")==0)
		{
			nr_founders = atol(argv[++i]);
		}
		else if (strcasecmp(argv[i],"-seed")==0)
		{
			init_rand(atol(argv[++i]));
		}
		else if (strcasecmp(argv[i],"-founder_bias")==0)
		{
			founder_bias = atol(argv[++i]);
		}
		else if (strcasecmp(argv[i],"-noise")==0)
		{
			noise = atol(argv[++i]);
		}
		else if (strcasecmp(argv[i],"-max_steps")==0)
		{
			max_steps = atol(argv[++i]);
		}
		else if (strcasecmp(argv[i],"-flanking")==0)
		{
			flanking = atol(argv[++i]);
		}
		else if (strcasecmp(argv[i],"-anc_map")==0)
		{
			argvFrontInputIMP[7] = argv[++i];
			bHas_anc_map = true;
		}
		else if (strcasecmp(argv[i],"-PROBS")==0)
		{
			bOutputProb = true;
		}
		else if (strcasecmp(argv[i],"-hap_training_file")==0)
		{
			fprintf(stderr,"To use -gen_imput_file parm, set 1st argument = [GEDIcore]\n");
			return -1;
		}
		else if (strcasecmp(argv[i],"-gen_input_file")==0)
		{
			fprintf(stderr,"To use -gen_imput_file parm, set 1st argument = [GEDIcore]\n");
			return -1;
		}
		else if( (strcasecmp(argv[1],"-h")==0) || (strcasecmp(argv[1],"-help")==0) )
		{
			badparam = true;
		}
		else
		{
			fprintf(stderr,"Unrecognized command line parameter: %s\n",argv[i]);
			badparam = true;
		}
	}

	if(!bHas_ref_snp_info)
	{
//		fprintf(stderr,"-ref_snp_info <file_name> is required\n");
		badparam = true;
	}
	if(!bHas_pop_snp_info)
	{
//		fprintf(stderr,"-pop_snp_info <file_name> is required\n");
		badparam = true;
	}
	if(!bHas_ref_chr_hap)
	{
//		fprintf(stderr,"-ref_chr_hap <file_name> is required\n");
		badparam = true;
	}
	if(!bHas_pop_ped)
	{
//		fprintf(stderr,"-pop_ped <file_name> is required\n");
		badparam = true;
	}
	if(!bHas_pop_chr_gen)
	{
//		fprintf(stderr,"-pop_chr_gen <file_name> is required\n");
		badparam = true;
	}
	if(!bHas_anc_map)
	{
//		fprintf(stderr,"-anc_map <file_name> is required\n");
		badparam = true;
	}
	if( (argc<2) || badparam )
	{
		fprintf(stderr,"Usage:\n\
./GEDI-ADMX <COMMANDS> <REQUIRED_ARGUMENTS> <OPTIONAL_ARGUMENTS>\n\
\n\
\n\
COMMANDS:\n\
\n\
        [-PROBS]                      : output imputation probabilities\n\
\n\
        [-EDC [-LLRT <N>]]            : Perform error detection on input\n\
                                        genotype data, correcting SNP\n\
                                        genotypes with log-likelihood\n\
                                        ratio above <N> (default 3)\n\
\n\
        [-MDR]                        : Perform imputation of missing\n\
                                        genotypes at typed SNP\n\
\n\
        [-IMP <imp_snp> [-flanking <K>]] : Impute untyped SNPs listed in\n\
                                        <imp_snp> using inferred local\n\
                                        ancestry and posterior probability\n\
                                        based on <K> (default 10) typed\n\
                                        SNPs before and after imputed\n\
                                        locus\n\
\n\
REQUIRED_ARGUMENTS:\n\
\n\
        -chr <chr_number>               : chromosome number\n\
        -pop_snp_info <snp_info_file>   : info file for typed SNPs\n\
        -pop_ped <ped_file>             : population pedigree file\n\
        -pop_chr_gen <row_genotype_file>: typed SNP genotypes in row format\n\
        -ref_chr_hap <hap_file>         : reference haplotypes for\n\
                                          ancestral populations\n\
        -ref_snp_info <snp_info_file>   : info file for reference SNPs\n\
        -anc_map <anc_map file>         : list of ancestral populations\n\
\n\
OPTIONAL_ARGUMENTS:\n\
\n\
        -excl_sample <sample_list>      : individuals to exclude\n\
        -excl_snp <snp_list>            : SNPs to exclude\n\
        -output_file_name <file>        : output file name (default is to\n\
                                          use the prefix of the population\n\
                                          genotype file name)\n");
		exit(0);
	}

	if ((1.5*half_overlap) >= blocksize)
	{
		printf("-half overlap %d must be less than a third the blocksize (%d)\n",half_overlap/2,blocksize);
		return -1;
	}
	FILE * fSummary = fopen("Summary.txt","w");
	fprintf(fSummary,"******GEDI-ADMX SUMMARY FILE***********\n");
	fprintf(fSummary,"Command Line: ");
	for(int j = 1; j < argc; j++)
	{
		fprintf(fSummary,"%s ",argv[j]);
	}
	fprintf(fSummary,"\n");
	fclose(fSummary);
	if(argvFrontInputIMP[2] == "") //if no ref_snp_info file, use pop_snp_input_file
	{
		argvFrontInputIMP[2] = argvFrontInputIMP[3];
		bSpecialPhase = true;
	}
	fprintf(stderr,"Running imputation\n");
    double startTime = (double)clock();
	fSummary = fopen("Summary.txt","a");
	fprintf(fSummary,"SUMMARY:\n");
	fclose(fSummary);
//Front End
	iFront = mainGEDIFront(12,argvFrontInputIMP);
	double endTime = (double)clock();
	fSummary = fopen("Summary.txt","a");
	#if defined(_WIN32) || defined(_WIN64)
		fprintf(fSummary," \t%f seconds for GEDI-ADMX Front End\n",((endTime-startTime)/1000));
	#else
		fprintf(fSummary," \t%f seconds for GEDI-ADMX Front End\n",((endTime-startTime)/1000000));
	#endif
	startTime = (double)clock();
	fclose(fSummary);
//Core
	fprintf(stderr,"\nRunning GEDI-ADMX Core\n");
	mainGEDI();
	return 0;
}
//What used to be the front end:
typedef struct GEN{
	char snp_id[20];
	char sample_id[20];
	char a0;
	char a1;
    float q;
}GEN;

static char reverseAllele(char val)
{
	if(val == 'A') return 'T';
	else if(val == 'C') return 'G';
	else if(val == 'G') return 'C';
	else if(val == 'T') return 'A';
	else return val;
}
static int comp_gen_snp_id(const void *m1, const void *m2) 
{
            GEN *mi1 = (GEN *) m1;
            GEN  *mi2 = (GEN *) m2;
            return strcmp(mi1->snp_id, mi2->snp_id);
}
static int comp_gen_sample(const void *m1, const void *m2) 
{
            GEN *mi1 = (GEN *) m1;
            GEN  *mi2 = (GEN *) m2;
            return strcmp(mi1->sample_id, mi2->sample_id);
}
static int comp_snp_pos1(const void *m1, const void *m2) 
{
    SNP *mi1 = (SNP *) m1;
    SNP  *mi2 = (SNP *) m2;
	return mi1->pos_in_gen - mi2->pos_in_gen;
}


int search_gen_id(char *gen_id,int start, int end)
{
	if(end<start) return -1;
	
	for(int i = start; i < end;i++)
	{
		if(0==strcmp(gen_id, ped_map[i].id))
			return i;
	}
	return -1;
}
double SNPHWE(int obs_hets, int obs_hom1, int obs_hom2);
//#include "snp_hwe.cpp"

bool isValidAllelePair(char a0, char a1, char b0, char b1)
{
	if(a0 == b0)
	{
		if(a1 == b1) return true;
		else return false;
	}
	else
	{
		if((a0 == b1)&&(a1 == b0)) return true;
		else return false;
	}
}

int mainGEDIFront(int argc, char** argv)
{
	int chr;
	int nr_xsnp;
	char ** hapTrain;
	int * hapTrainAnc_Map; //Used to describe the index of the ancestor each haplotype in hapTrain belongs to
	int hapTrainCount;
	if((argc<11)||(argc>12))
	{
		fprintf(stderr,"usage:: %s gen_file hsnp_file wsnp_file ped_file samples2remove_file xsnps_file isnp_file hap_training_file chr IGNORE anc_map\n",argv[0]);
		return 0;
	}
	FILE *fgen,*fmap,*fmap1, *fped, *frsamples,*frsnps, *fhapTraining, *fAncMap, *fimp;
	fgen = fopen(argv[1],"r");
	if(!fgen) fprintf(stderr,"Could not open pop_chr_gen file %s\n",argv[1]);
	fmap = fopen(argv[2],"r");
	if(!fmap) fprintf(stderr,"Could not open ref_snp_info file %s\n",argv[2]);
	fmap1 = fopen(argv[3],"r");
	if(!fmap1) fprintf(stderr,"Could not open pop_snp_info file %s\n",argv[3]);
	fped = fopen(argv[4],"r");	
	if(!fped) fprintf(stderr,"Could not open pop_ped file %s\n",argv[4]);
	frsamples = fopen(argv[5],"r");
//	if(!frsamples) fprintf(stderr,"Could not open excl_sample file %s\n",argv[5]);
	frsnps = fopen(argv[6],"r");
//	if(!frsnps) fprintf(stderr,"Could not open excl_snp file %s\n",argv[6]);
	fAncMap = fopen(argv[7],"r");
	if(!fAncMap) fprintf(stderr,"Could not open anc_map file %s\n",argv[7]);
	fhapTraining = fopen(argv[8],"r");
	if(!fhapTraining) fprintf(stderr,"Could not open ref_chr_hap file %s\n",argv[8]);
	chr = atoi(argv[9]);
	fimp = fopen(argv[10],"r");
//	if(!fimp) fprintf(stderr,"Could not open imp_snp file %s\n",argv[10]);	
	if(!fgen || !fmap ||!fmap1 || !fped ||!fhapTraining)
	{
		fprintf(stderr,"could not open input files\n");
		return -1;
	}
	iSNPRemoved = 0;
	nr_samples = 0;
	char * line = NULL;
	size_t len = 0;
	char dummyStr[1000];
	/*read ANC MAP file-IDs should map to what's in the 1st column of the ref_chr_hap/fhaptraining file*/
	hmmCount = 0;
	while(fscanf(fAncMap,"%s\n",dummyStr) > 0) hmmCount++;
	rewind(fAncMap);
	anc_map = (ANC_HMM*)calloc(hmmCount, sizeof(ANC_HMM));
	int iCurrHMM = 0;
	while(fscanf(fAncMap,"%s\n",anc_map[iCurrHMM].name) > 0)
	{
		anc_map[iCurrHMM].nr_genANC = 0;
		iCurrHMM++;
	}
	/* read SNPs map data*/
	/*get number of SNPs in file*/
	nr_hsnp=0;
	nr_xsnp=0;
	int dummyPos;
	char dummya0;
	char dummya1;
	fscanf(fmap,"%s %s %s %s\n",dummyStr,dummyStr1,dummyStr2,dummyStr3);
	while(fscanf(fmap,"%s %d %c %c\n", dummyStr, &dummyPos, &dummya0,&dummya1) > 0) 
	{
		nr_hsnp++;
	}
	fprintf(stderr,"SNPs found in reference SNP file: %d\n",(nr_hsnp));
	rewind(fmap);
	
	snp_map = (SNP*)calloc(nr_hsnp, sizeof(SNP));
//Reading Reference SNPs
	fscanf(fmap,"%s %s %s %s",dummyStr,dummyStr1,dummyStr2,dummyStr3);
	fscanf(fmap,"%s\n",dummyStr4);
	if(strcasecmp(dummyStr4,"-strand")==0)	
	{
		bSpecialPhase = true;
	}
	else
	{
		rewind(fmap);
		fscanf(fmap,"%s %s %s %s\n",dummyStr,dummyStr1,dummyStr2,dummyStr3);
		bSpecialPhase = false;
	}
	int i=0;
	while(fscanf(fmap,"%s\t%d\t%c\t%c", snp_map[i].id, &snp_map[i].pos, &snp_map[i].a0, &snp_map[i].a1) > 0)
	{
		if(bSpecialPhase) fscanf(fmap,"\t%s\n",dummyStr1); //strand...
		else fscanf(fmap,"\n");
		snp_map[i].chr=chr; 
		snp_map[i].failed_hwe_test=false; 
		snp_map[i].isHSNP = true; 
		snp_map[i].isWSNP = false; 
		snp_map[i].isISNP = false; 
		snp_map[i].isXSNP = false; 
		snp_map[i].a0HapCount = 0; 
		snp_map[i].a1HapCount = 0; 
		snp_map[i].a0GenCount = 0; 
		snp_map[i].a1GenCount = 0; 
		snp_map[i].obs_hets = 0; 
		snp_map[i].obs_hom0 = 0; 
		snp_map[i].obs_hom1 = 0; 
		snp_map[i].freqFlip = false;
		if((snp_map[i].a0=='-')||(snp_map[i].a0==snp_map[i].a1))
		{
//			fprintf(stderr,"inconsistent SNP detected - for SNP %s\n",snp_map[i].id);
			snp_map[i].a0 = snp_map[i].a1;
			snp_map[i].a1 = '-';
			snp_map[i].ia0 = snp_map[i].a1;
			snp_map[i].ia1 = '-';			
		}	
		i++;
	}
	fprintf(stderr,"Read %d reference SNPs\n",i);
//Read Hapmap Haplotype file
	bool bPhaseIn = false; // special phasing file used as input
	fscanf(fhapTraining,"%s",dummyStr1);
	if(strcasecmp(dummyStr1,"-phase")==0)
	{
		bPhaseIn = true;
	}
	else
	{
		rewind(fhapTraining);
		char currVal;
		int currSNP = nr_hsnp;
		int currHap = 0;
		fscanf(fhapTraining,"%s ",dummyStr); //skip the Anc Id on the first pass
		while(fscanf(fhapTraining,"%c ", &currVal) > 0)
		{
			if(currVal=='0'||currVal=='1')
			{
				if(currSNP == (nr_hsnp-1))
				{
					fscanf(fhapTraining,"%s ",dummyStr);//skip the Anc Id on the first pass
				}
				if(currSNP == nr_hsnp)
				{
					currSNP = 1;
					currHap++;
				}
				else currSNP++;
			}
			else
			{
				fprintf(stderr,"Invalid haplotype value in reference haplotype file: %c currSNP=%d currHap=%d\n",currVal,currSNP,currHap);
			}
		}
		hapTrainCount = currHap;
		rewind(fhapTraining);		
		hapTrain = (char**)malloc((hapTrainCount+1)*sizeof(char*));
		hapTrainAnc_Map = (int*)malloc((hapTrainCount+1)*sizeof(int));
		for(int j = 0; j < (hapTrainCount+1);j++)
		{
			hapTrain[j] = (char*)malloc((nr_hsnp)*sizeof(char));
//			for(int s = 0; s < nr_hsnp; s++)
//			{
//				hapTrain[j][s] = '0';
//			}
		}
		currSNP = 0;
		currHap = 0;
		char ancName[20];
		fscanf(fhapTraining,"%s ",ancName);
		hapTrainAnc_Map[currHap] = getAncIndex(ancName);
		while((currHap<hapTrainCount)&&(fscanf(fhapTraining,"%c ", &hapTrain[currHap][currSNP++]) > 0))
		{
			if ( (currHap < hapTrainCount -1) &&(currSNP == nr_hsnp) )
			{
				//Scan once more, should be '\n'
				currHap++;
				currSNP = 0;
				fscanf(fhapTraining,"%s ",ancName);
				hapTrainAnc_Map[currHap] = getAncIndex(ancName);
			}
			else if( currSNP>0 && hapTrain[currHap][currSNP-1]!='0'&&hapTrain[currHap][currSNP-1]!='1')
			{
				fprintf(stderr,"Invalid haplotype value in reference haplotype file: %c currSNP %d currHap %d\n",hapTrain[currHap][currSNP-1],currSNP,currHap);
			}
		}
	}
//Read PED: pedigree data
	while(fscanf(fped,"%s %s %s\n", dummyStr1,dummyStr2, dummyStr3) >0) 
	{
		nr_samples++;
	}
	nr_samples--;	
	fprintf(stderr,"Samples found in pedigree file: %d\n",nr_samples);
	rewind(fped);

	ped_map = (PED*)malloc(nr_samples*sizeof(PED));
	i=0;
	fscanf(fped,"%s %s %s\n", dummyStr1,dummyStr2, dummyStr3);
	while(fscanf(fped,"%s %s %s\n", ped_map[i].id,ped_map[i].fid, ped_map[i].mid) >0)
	{
		i++;
		ped_map[i].to_remove = false;
	}
	fprintf(stderr,"Read %d samples in pedigree file\n",i);
	
	fprintf(stderr,"Sorting pedigree map...");
	qsort(ped_map, nr_samples, sizeof(struct PED),comp_ped_map_gen_id);
	fprintf(stderr,"done\n");


	fprintf(stderr,"Sorting SNPs by id...");
	qsort(snp_map, nr_hsnp, sizeof(struct SNP),comp_snp_id);
	fprintf(stderr,"done\n");
//Read ISNP: Data to impute
	char impID[20];
	if(bHas_imp_snp)
	{
		while(fscanf(fimp,"%s\n", impID) > 0)
		{
			int snp_pos = bin_search_snp_id(impID, 0 , nr_hsnp-1);
			if(snp_pos >= 0)
			{
				snp_map[snp_pos].isISNP = true;
			}
		}
	}
	fprintf(stderr,"Sorting SNPs by position...");
	qsort(snp_map, nr_hsnp, sizeof(struct SNP),comp_snp_pos);
	fprintf(stderr,"done\n");
	for(i=0; i < nr_hsnp;i++)
	{
		snp_map[i].pos_in_gen=i;
		for(int j = 0; j < hapTrainCount; j++)
		{
			if(hapTrain[j][i] == '0')
			{
				snp_map[i].a0HapCount++;
			}
			else if(hapTrain[j][i] == '1')
			{
				snp_map[i].a1HapCount++;
			}
			else fprintf(stderr,"Invalid haplotype %c at hap training # %d, SNP %d",hapTrain[j][i],j,i);
		}
	}
	fprintf(stderr,"Sorting SNPs by id...");
	qsort(snp_map, nr_hsnp, sizeof(struct SNP),comp_snp_id);
	fprintf(stderr,"done\n");

//Read XPSNP: SNP Data to remove
	i=0;
	char snp2rem[20];
	if(frsnps)
	{
		fscanf(frsnps,"%s\n", snp2rem);
		while(fscanf(frsnps,"%s\n", snp2rem) > 0)
		{
			int snp_pos = bin_search_snp_id(snp2rem,0,nr_hsnp-1);
			if((snp_pos >= 0 )&&(snp_map[snp_pos].isISNP== false))
			{
				snp_map[snp_pos].isXSNP = true;
				i++;
			}
		}
	}
	fprintf(stderr,"read %d SNPs to remove\n",i);
	FILE * fSummary = fopen("Summary.txt","a");
	fprintf(fSummary,"\tNumber of SNPs Excluded: %d\n",i);
	fclose(fSummary);
	i=0;
	char snpid[20];
	int snppos;
	char snpa0,snpa1,strand; 
	fscanf(fmap1,"%s",snpid);
	if(strcasecmp(snpid,"#rsID")!=0) 
	{
		rewind(fmap1);
	}
	else 
	{
		fscanf(fmap1,"%s %s %s %s\n", dummyStr1, dummyStr2, dummyStr3,dummyStr4);//header
	}
//Read Pop_snp: SNPs on known data (e.g. Affy500k)
	while(fscanf(fmap1,"%s %d %c %c %c\n", snpid, &snppos, &snpa0, &snpa1, &strand) > 0){
		int snp_pos = bin_search_snp_id(snpid, 0 , nr_hsnp-1);
		if(snp_pos >= 0)
		{
			if(strand == '+') 
			{
			//o.k., passed the first test
				snp_map[snp_pos].reversed = false;
			}
			else if(strand == '-') 
			{
				char curra0 = reverseAllele(snpa1);
				char curra1 = reverseAllele(snpa0);
				snpa0 = curra0;
				snpa1 = curra1;
				snp_map[snp_pos].reversed = true;
			}
			else 
			{	
				fprintf(stderr,"Bad strand %c in SNP %s for the pop_snp_info file %s\n",strand,snpid,argv[3]);
			}
			snp_map[snp_pos].isWSNP = true;	
			if((isValidAllelePair(snp_map[snp_pos].a0,snp_map[snp_pos].a1, snpa0, snpa1)==false)&&(isValidAllelePair(reverseAllele(snp_map[snp_pos].a0),reverseAllele(snp_map[snp_pos].a1),snpa0,snpa1))==false)
			{
				snp_map[snp_pos].isXSNP = true;
				iSNPRemoved++;
				fprintf(stderr,"Warning: SNP %s ignored since allele values between ref_snp_info [%c/%c] and pop_snp_info [%c/%c] files do not match\n",snp_map[snp_pos].id,snp_map[snp_pos].a0,snp_map[snp_pos].a1,snpa0,snpa1);
			}
			i++;
		}
		else 
		{
			fprintf(stderr, "Warning: SNP ID %s not found in the reference SNP file\n", snpid);
		}
	}
	fprintf(stderr,"Read %d SNPs in the population SNP file, that are also in the reference SNP file \n",i);
	i=0;
	char sample2rem[20];
	int nr_removed=0;
//Read XPED: Pedigree Data to remove
	if(frsamples)
	{
		fscanf(frsamples,"%s\n", sample2rem);
		while(fscanf(frsamples,"%s\n", sample2rem) > 0)
		{
			int sample_pos = bin_search_gen_id(sample2rem,0,nr_samples-1);	
			if(sample_pos > 0 )
			{
				fprintf(stderr,"Removing %s sample\n",ped_map[sample_pos].id);
				ped_map[sample_pos].to_remove = true;
				nr_removed++;
			}
		}
	}
	fprintf(stderr,"read %d Samples to remove\n",nr_removed);
	fSummary = fopen("Summary.txt","a");
	fprintf(fSummary,"\tNumber of Individuals Removed: %d\n",nr_removed);
	fclose(fSummary);
	char ** gen_a0; //Sample/SNP matrix of allele values for 1st allele in pop_chr_gen
	char ** gen_a1; //Sample/SNP matrix of allele values for 2nd allele in pop_chr_gen
	gen_a0 = (char**)malloc(nr_samples*sizeof(char*));
	gen_a1 = (char**)malloc(nr_samples*sizeof(char*));
	for(i =0; i < nr_samples;i++)
	{
		gen_a0[i] = (char*)malloc(nr_hsnp*sizeof(char));
		gen_a1[i] = (char*)malloc(nr_hsnp*sizeof(char));
		for(int j =0; j < nr_hsnp;j++)	
		{
			gen_a0[i][j] = '?';
			gen_a1[i][j] = '?';
		}
	}
	fprintf(stderr,"Processing genotype file\n");
	char snp_id[30];
	char sample_id[30];
	char a0;
	char a1;
	float q;
	i=0;
	nr_err=0;

//Read Phase Data
	if(bPhaseIn)
	{
/*
		char h0;
		char h1;
		fscanf(fhapTraining,"%s\t%s\t%s\t%s\n",dummyStr1,dummyStr2,dummyStr3,dummyStr4);
		while(fscanf(fhapTraining,"%s\t%s\t%c\t%c\n",snp_id,sample_id,&h0,&h1) > 0)
		{
			int idx_sample = bin_search_gen_id(sample_id, 0, nr_samples-1);
			int idx_snp = bin_search_snp_id(snp_id,0,nr_hsnp-1);
			if(idx_sample >= 0 && idx_snp >=0 && idx_sample < nr_samples )
			{
				hapTrain[idx_sample*2][snp_map[idx_snp].pos_in_gen] = h0;
				hapTrain[idx_sample*2+1][snp_map[idx_snp].pos_in_gen] = h1;
			}
			i++;
			if(0==i%1000000)
				fprintf(stderr,".");
			}
*/
	}
//Read Genotype pop_chr_gen Data: Genotype Input processing...the big guy
	int maxSNPID = 0;
	int minSNPID = 0;
	int maxSampleID = 0;
	int minSampleID = 0;
	fscanf(fgen,"%s\t%s\t%s\t%s\t%s\n", dummyStr1, dummyStr2, dummyStr3, dummyStr4, dummyStr5);
	while(fscanf(fgen,"%s\t%s\t%c\t%c\t%f\n", snp_id, sample_id, &a0, &a1, &q) > 0)
	{
		int idx_sample = bin_search_gen_id(sample_id, 0, nr_samples-1);
		int idx_snp = bin_search_snp_id(snp_id,0,nr_hsnp-1);
		if(idx_sample > maxSampleID) maxSampleID = idx_sample;
		if(idx_sample < minSampleID) 
		{
			minSampleID = idx_sample;
		}
		if(idx_snp > maxSNPID) maxSNPID = idx_snp;
		if(idx_snp < minSNPID) minSNPID = idx_snp;
		if(idx_sample >= 0 && idx_snp >=0 && idx_sample < nr_samples )
		{
			if((a0!='A')&&(a0!='C')&&(a0!='T')&&(a0!='G')&&(a0!='0')&&(a0!='1')) a0 = '?';
			if((a1!='A')&&(a1!='C')&&(a1!='T')&&(a1!='G')&&(a1!='0')&&(a1!='1')) a1 = '?';
			if(snp_map[idx_snp].isISNP)
			{
				a0 = '?';
				a1 = '?';
			}
				gen_a0[idx_sample][snp_map[idx_snp].pos_in_gen] = a0;
				gen_a1[idx_sample][snp_map[idx_snp].pos_in_gen] = a1;
			int genVal = -1;
			if(gen_a0[idx_sample][snp_map[idx_snp].pos_in_gen] == snp_map[idx_snp].a0)
			{
				snp_map[idx_snp].a0GenCount++;
				genVal = 0;
			}
			else if(gen_a0[idx_sample][snp_map[idx_snp].pos_in_gen] == snp_map[idx_snp].a1)
			{
				snp_map[idx_snp].a1GenCount++;
				genVal = 1;
			}
			else if(((snp_map[idx_snp].isISNP == false))&&(snp_map[idx_snp].isXSNP == false))
			{
				snp_map[idx_snp].a1GenCount++;
				char genoAllele = gen_a0[idx_sample][snp_map[idx_snp].pos_in_gen];
				char hap0Allele = snp_map[idx_snp].a0;
				char hap1Allele = snp_map[idx_snp].a1;
				snp_map[idx_snp].isXSNP = true; 		
				iSNPRemoved++;
				fprintf(stderr,"Warning: excluding additional SNP %s since individual %s has a Genotype allele value %c that does not match the reference list: [%c,%c]\n",snp_id,sample_id,genoAllele,hap0Allele,hap1Allele);
			}
			if(gen_a1[idx_sample][snp_map[idx_snp].pos_in_gen] == snp_map[idx_snp].a0) 
			{
				snp_map[idx_snp].a0GenCount++;
				if(genVal == 0) snp_map[idx_snp].obs_hom0++;
				else if(genVal == 1) snp_map[idx_snp].obs_hets++;
				else genVal = -1; //invalid!
			}
			else if(gen_a1[idx_sample][snp_map[idx_snp].pos_in_gen] == snp_map[idx_snp].a1) 
			{
				snp_map[idx_snp].a1GenCount++;
				if(genVal == 0) snp_map[idx_snp].obs_hets++;
				else if(genVal == 1) snp_map[idx_snp].obs_hom1++;
			}
			else if(((snp_map[idx_snp].isISNP == false))&&(snp_map[idx_snp].isXSNP == false))
                        {
				snp_map[idx_snp].a0GenCount++;
				char genoAllele = gen_a0[idx_sample][snp_map[idx_snp].pos_in_gen]; 
				char hap0Allele = snp_map[idx_snp].a0;
				char hap1Allele = snp_map[idx_snp].a1;
				snp_map[idx_snp].isXSNP = true; 		
				iSNPRemoved++;
				fprintf(stderr,"Warning: excluding additional SNP %s since individual %s has a Genotype allele value %c that does not match the reference list: [%c,%c]\n",snp_id,sample_id,genoAllele,hap0Allele,hap1Allele);
                        }
		}
		else if ((idx_snp >=0)&&(idx_sample>=0))
		{
			if(snp_map[idx_snp].isISNP)  //imputatble snps...
			{
				a0 = '?';
				a1 = '?';
				q = 1.0;
				gen_a0[idx_sample][snp_map[idx_snp].pos_in_gen] = a0;
				gen_a1[idx_sample][snp_map[idx_snp].pos_in_gen] = a1;
			}
		}
		i++;
		if(0==i%1000000)
			fprintf(stderr,".");
	}
	fprintf(stderr,"\nDone processing %d genotypes\n",i);
//End Processing Genotype Big file
	fprintf(stderr,"Sorting SNPs by global position...");
	qsort(snp_map, nr_hsnp, sizeof(struct SNP),comp_snp_pos);
	fprintf(stderr,"done\n");
	
	totalSNPSize = 0;
	for(i =0; i < nr_hsnp; i++)
	{
		if(snp_map[i].isHSNP == false) 
		{
			snp_map[i].isXSNP = true;
		}
		if((snp_map[i].isWSNP == true)&&((!snp_map[i].isISNP))&&(snp_map[i].a0GenCount+snp_map[i].a1GenCount > 0))
		{
			int hapCount = snp_map[i].a0HapCount + snp_map[i].a1HapCount;
			int genCount = snp_map[i].a0GenCount + snp_map[i].a1GenCount;
			snp_map[i].a0HapFreq = (double)snp_map[i].a0HapCount/(double)(hapCount);
			snp_map[i].a1HapFreq = (double)snp_map[i].a1HapCount/(double)(hapCount);
			snp_map[i].a0GenFreq = (double)snp_map[i].a0GenCount/(double)(genCount);
			snp_map[i].a1GenFreq = (double)snp_map[i].a1GenCount/(double)(genCount);
//			snp_map[i].hweVal = SNPHWE(snp_map[i].obs_hets, snp_map[i].obs_hom0, snp_map[i].obs_hom1); 
			snp_map[i].hweVal = 0;
			double a0Diff = snp_map[i].a0HapFreq-snp_map[i].a0GenFreq;
			double obs0Count = snp_map[i].a0HapFreq*hapCount+1.0;
			double obs1Count = snp_map[i].a1HapFreq*hapCount+1.0;
			double exp0Count = snp_map[i].a0GenFreq*hapCount+1.0;
			double exp1Count = snp_map[i].a1GenFreq*hapCount+1.0;
		}			
		else if((snp_map[i].isWSNP == true)&&((!snp_map[i].isISNP))&&(snp_map[i].a0GenCount+snp_map[i].a1GenCount == 0))
		{
			fprintf(stderr,"Warning: snp %s is being ignored- This SNP is in the population SNP file, but no genotypes were found in the population genotype file\n",snp_map[i].id);
			snp_map[i].isXSNP = true;
			iSNPRemoved++;
		}
		if(((!snp_map[i].isXSNP)&&(snp_map[i].isISNP)&&(snp_map[i].isHSNP))||
			((!snp_map[i].isXSNP)&&(snp_map[i].isWSNP)&&(snp_map[i].isHSNP)))
			totalSNPSize++;
		else
		{
			snp_map[i].isXSNP = true;
		}

	}
	if(iSNPRemoved > 0)
	{
		FILE * fSummary = fopen("Summary.txt","a");
		fprintf(fSummary,"\t%d SNPs ignored (see warnings)\n",iSNPRemoved);
		fclose(fSummary);
	}
//Create GenoImpute files
	nr_gen_to_estimate = nr_samples - nr_removed;
//	nr_snp = totalSNPSize;
	gen_to_est_array_full = (char**)malloc(nr_gen_to_estimate*sizeof(char*));
	for(i = 0; i < nr_gen_to_estimate;i++)
	{
		gen_to_est_array_full[i] = (char*)malloc((nr_hsnp)*sizeof(char));
	}
	int gediSampleID = 0;
	int snpInd;
	gen_indiv_id = (int*)malloc(nr_gen_to_estimate*sizeof(int));
	for(int sampleid =0; sampleid < nr_samples; sampleid++)
	{
		if(ped_map[sampleid].to_remove == false)
		{
			int id =sampleid;
			int fid=-1;
			int mid=-1;
			int ii=0;
			if(0 != strcmp("0",ped_map[id].fid))
			{
				for(int i=0; (fid==-1) && (i < nr_samples); i++)
				{
					if(0==strcmp(ped_map[i].id, ped_map[id].fid))
						fid = i;
				}
			}
			if(0 !=strcmp("0",ped_map[id].mid))
			{
				for(int i=0; (mid==-1) && (i < nr_samples); i++)
				{
					if(0==strcmp(ped_map[i].id, ped_map[id].mid))
						mid = i;
				}
			}
			char c;
			if(fid<0 &&mid <0) c= 'F';
			else c= 'C';	 
			gen_indiv_id[sampleid] = id+1;
			char dummyRel = c;
			snpInd = 0;
			for(int i = 0; i< nr_hsnp;i++)
			{
				if(((!snp_map[i].isXSNP)&&(snp_map[i].isISNP)&&(snp_map[i].isHSNP))||
				((!snp_map[i].isXSNP)&&(snp_map[i].isWSNP)&&(snp_map[i].isHSNP)))
				{
					if((gen_a0[sampleid][i] == '?') || (gen_a1[sampleid][i] == '?'))
					{
						gen_to_est_array_full[gediSampleID][snpInd] = '?';
					}
					else if(gen_a0[sampleid][i] != gen_a1[sampleid][i] )
					{						
						gen_to_est_array_full[gediSampleID][snpInd] = '2';
					}
					else if(snp_map[i].a0!='\0' && gen_a0[sampleid][i] == snp_map[i].a0)
					{
						if(snp_map[i].freqFlip == false) 
						{
							gen_to_est_array_full[gediSampleID][snpInd] = '0';
						}
						else 
						{
							gen_to_est_array_full[gediSampleID][snpInd] = '1';
						}
					}
					else if(snp_map[i].a0!='\0' && gen_a0[sampleid][i] == snp_map[i].a1)
					{
						if(snp_map[i].freqFlip == false) 
						{
							gen_to_est_array_full[gediSampleID][snpInd] = '1';
						}
						else 
						{
							gen_to_est_array_full[gediSampleID][snpInd] = '0';
						}
					}
					else if(snp_map[i].a1=='-')
					{
						snp_map[i].a1 = gen_a0[sampleid][i];
						snp_map[i].ia1 = gen_a0[sampleid][i];
						if(snp_map[i].freqFlip == false) 
						{
							gen_to_est_array_full[gediSampleID][snpInd] = '1';
						}
						else
		 				{
							gen_to_est_array_full[gediSampleID][snpInd] = '0';
						}
					}
					else
					{
						fprintf(stderr,"Allele a0 a1 assignment error at SNP %d %s (%c %c) -> (%c %c)\n",
						i,
						snp_map[i].id,
						gen_a0[sampleid][i],
						gen_a1[sampleid][i],
						snp_map[i].a0,
						snp_map[i].a1);	
						getchar();
					}
					snpInd++;
				}
			}
			gediSampleID++;
		}
	}
/*end conv*/
	for(i =0; i < nr_samples;i++)
	{
		free(gen_a0[i]);
		free(gen_a1[i]);
	}
	free(gen_a0);
	free(gen_a1);
//This is where we output the haplotype training file
//initialize nr_gen per hmm for training (nr_genANC)
	nr_gen = hapTrainCount; 
	for(int h = 0; h < hmmCount; h++)
	{
		for(int i = 0; i < nr_gen; i++)
		{
			if(hapTrainAnc_Map[i]==h) 
			{
				anc_map[h].nr_genANC++;
			}
		}
	}

	//nr_snp = totalSNPSize; //conv
	for(int h = 0; h < hmmCount; h++)
	{
		int snpInd;
		anc_map[h].hap_array_full_ANC = (char**)malloc((2*anc_map[h].nr_genANC) * sizeof(char*)); //conv			
		for(int i = 0; i < anc_map[h].nr_genANC; i++)
		{
				anc_map[h].hap_array_full_ANC[2*i] = (char*)malloc((totalSNPSize)*sizeof(char));
				anc_map[h].hap_array_full_ANC[2*i+1] = (char*)malloc((totalSNPSize)*sizeof(char));
		}
		int currI = 0;
		for(int i = 0; i < nr_gen; i++)
		{
			if(hapTrainAnc_Map[i]==h) 
			{
				snpInd = 0;
				for(int j = 0; j < nr_hsnp;j++)
				{
					if(((!snp_map[j].isXSNP)&&(snp_map[j].isISNP)&&(snp_map[j].isHSNP))||
					((!snp_map[j].isXSNP)&&(snp_map[j].isWSNP)&&(snp_map[j].isHSNP)))							
					{
						anc_map[h].hap_array_full_ANC[2*currI][snpInd] = hapTrain[i][j];
						snpInd++;
					}
				}
				snpInd = 0;
				for(int j = 0; j < nr_hsnp;j++)
				{
					if(((!snp_map[j].isXSNP)&&(snp_map[j].isISNP)&&(snp_map[j].isHSNP))||
					((!snp_map[j].isXSNP)&&(snp_map[j].isWSNP)&&(snp_map[j].isHSNP)))							
					{
						anc_map[h].hap_array_full_ANC[2*currI+1][snpInd] = hapTrain[i][j];
						snpInd++;
					}
				}
				currI++;
			}//end if
		}//end for nr_genAnc loop
	}//end for hmmCount Loop
	free(hapTrainAnc_Map);
	for(int j = 0; j < (hapTrainCount+1);j++)
	{
		free(hapTrain[j]);
	}
	free(hapTrain);
	return 0;
}
//HWE stuff:
/*
// This code implements an exact SNP test of Hardy-Weinberg Equilibrium as described in
// Wigginton, JE, Cutler, DJ, and Abecasis, GR (2005) A Note on Exact Tests of 
// Hardy-Weinberg Equilibrium. American Journal of Human Genetics. 76: 000 - 000  
//
// Written by Jan Wigginton
*/
double SNPHWE(int obs_hets, int obs_hom1, int obs_hom2)
{
   if (obs_hom1 < 0 || obs_hom2 < 0 || obs_hets < 0) 
      {
      printf("FATAL ERROR - SNP-HWE: Current genotype configuration (%d  %d %d ) includes a"
             " negative count", obs_hets, obs_hom1, obs_hom2);
      exit(EXIT_FAILURE);
      }
   int obs_homc = obs_hom1 < obs_hom2 ? obs_hom2 : obs_hom1;
   int obs_homr = obs_hom1 < obs_hom2 ? obs_hom1 : obs_hom2;
   int rare_copies = 2 * obs_homr + obs_hets;
   int genotypes   = obs_hets + obs_homc + obs_homr;

   double * het_probs = (double *) malloc((size_t) (rare_copies + 1) * sizeof(double));
   if (het_probs == NULL) 
      {
      printf("FATAL ERROR - SNP-HWE: Unable to allocate array for heterozygote probabilities" );
      exit(EXIT_FAILURE);
      }
   int i;
   for (i = 0; i <= rare_copies; i++)
      het_probs[i] = 0.0;
   /* start at midpoint */
   int mid = rare_copies * (2 * genotypes - rare_copies) / (2 * genotypes);
   /* check to ensure that midpoint and rare alleles have same parity */
   if ((rare_copies & 1) ^ (mid & 1))
      mid++;
   int curr_hets = mid;
   int curr_homr = (rare_copies - mid) / 2;
   int curr_homc = genotypes - curr_hets - curr_homr;
   het_probs[mid] = 1.0;
   double sum = het_probs[mid];
   for (curr_hets = mid; curr_hets > 1; curr_hets -= 2)
      {
      het_probs[curr_hets - 2] = het_probs[curr_hets] * curr_hets * (curr_hets - 1.0)
                               / (4.0 * (curr_homr + 1.0) * (curr_homc + 1.0));
      sum += het_probs[curr_hets - 2];

      /* 2 fewer heterozygotes for next iteration -> add one rare, one common homozygote */
      curr_homr++;
      curr_homc++;
      }
   curr_hets = mid;
   curr_homr = (rare_copies - mid) / 2;
   curr_homc = genotypes - curr_hets - curr_homr;
   for (curr_hets = mid; curr_hets <= rare_copies - 2; curr_hets += 2)
      {
      het_probs[curr_hets + 2] = het_probs[curr_hets] * 4.0 * curr_homr * curr_homc
                            /((curr_hets + 2.0) * (curr_hets + 1.0));
      sum += het_probs[curr_hets + 2];
      /* add 2 heterozygotes for next iteration -> subtract one rare, one common homozygote */
      curr_homr--;
      curr_homc--;
      }
   for (i = 0; i <= rare_copies; i++)
      het_probs[i] /= sum;
   double p_hwe = 0.0;
   /*  p-value calculation for p_hwe  */
   for (i = 0; i <= rare_copies; i++)
      {
      if (het_probs[i] > het_probs[obs_hets])
         continue;
      p_hwe += het_probs[i];
      }
   
   p_hwe = p_hwe > 1.0 ? 1.0 : p_hwe;

   free(het_probs);

   return p_hwe;
   }

/*******************************************************************************
  author        : Justin Kennedy
  email			: jlk02019@engr.uconn.edu
  filename      : gedicore.cpp
  created       : 12.05.2007
*******************************************************************************/
bool bHasPedigree;
double ****forward_array;
double ****backward_array;
void print_hmm_fileJLK(HAP_HMM hmm, FILE *fout);
int* orderOfProcessing;  //Lists the order of genotype IDs to be processed with arbitrary pedigree structure
FILE* tfrDist;
char * genInputFile;
int convAlleleIntegerToChar(int val);
int convAlleleCharToInteger(int val);
void runGEDI(FILE * refout, FILE * fAlleleFreq);
//Extra Single stuff
double **array_uno_precomp1;
double *** totalProbUnoMatrix_forward;
double *** totalProbUnoMatrix_backward;
double ** totalProbUnoMatrix_unk;
double preCompute_total_uno1_backward(int a, int bpr, int j , HAP_HMM hmm);
double preCompute_total_uno1_forward(int a, int bpr, int j , HAP_HMM hmm);
double preCompute_total_uno1_unk(int a, int bpr, int j , HAP_HMM hmm);
double totalProbUnoAt_backward_fast(int a, int b, int j, int chi, HAP_HMM hmmOne, HAP_HMM hmmTwo);
double totalProbUnoAt_forward_fast(int a, int b, int j, int chi, HAP_HMM hmmOne, HAP_HMM hmmTwo);

//End Extra Single stuff
double *** totalProbMatrix; // Genotype Total matrix for single genotype
double totalProbAt(int a, int b, int j, int gi, HAP_HMM hmm); //Genotype Total for single genotype
double totalProb(char* gen, HAP_HMM hmm); //Genotype Total for single genotype

//End JLK
int convAlleleCharToInteger(char val);
bool update_hmm(HAP_HMM *hmm,double* new_pi, STATE** new_states,double*** new_trans);
double **forward_hap_array;
double **backward_hap_array;
void fill_forward_backward_hap_arrays(char* hap ,HAP_HMM hmm);
void compute_emmission_probMaxAvg(HAP_HMM *hmm);
int blocknum;
bool runPass1();//Admixed
bool runPass2();//Imputation
int currPass;
int getJEnd();
int getJStart();
void generateOrdering();
void printEndColumn(FILE* fout);
double trainingTime; 
int mainGEDI()
{
	double startTime = (double)clock();
	trainingTime = 0;
// 	FILE *fHMMout = fopen("HMM.txt","w");
//	fclose(fHMMout);
	fprintf(stderr,"training method BW\n");	
	generateOrdering(); //Order of processing indivudals, top down approach
	setMissingIndicators(); //Mark appropriate SNPs that are to be imputed, etc.
	currPass = 1;
	if(!runPass1()) exit(0);//This is the big part of the core
	fprintf(stderr,"Sorting SNPs by position...");
	qsort(snp_map, nr_hsnp, sizeof(struct SNP),comp_snp_pos);
	fprintf(stderr,"done\n");

	fprintf(stderr,"Sorting pedigree map...");
	qsort(ped_map, nr_samples, sizeof(struct PED),comp_ped_map_pos);
	fprintf(stderr,"done\n");
	if(bDoesEDC)
	{
		outputEDC();
	}
	if(bDoesMDR)
	{
		outputMDR();
	}
	if(bDoesIMP)
	{
		currPass = 2;
		if(!runPass2()) exit(0);//Imputation
		outputIMP();
	}
	freeMissingIndicators();
	outputAncestryInference();
	FILE *fSummary = fopen("Summary.txt","a");
	double totalTime = ((double)clock()-startTime);
	fprintf(fSummary,"\tGEDI-ADMX Time: %f seconds, (including %f seconds training) \n",(totalTime/1000000),trainingTime);
	fprintf(stderr,"Done Processing\n");
	return 0;
}

/* updates hmm and returns true if anything is modifed, false otherwise*/
bool update_hmm(HAP_HMM *hmm,double* new_pi, STATE** new_states,double*** new_trans)
{
/* make every prob higher than MIN_PROB*/
	/*1 pi*/
	for(int i =0; i< nr_founders; i++)
	{
		if( new_pi[i] < MIN_PROB)
			new_pi[i] = MIN_PROB;
	}
	/*2 transitions*/			
	for(int i =0; i < nr_snp-1; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{

			for(int k =0; k < nr_founders; k++)
			{
				if( new_trans[i][j][k] < MIN_PROB)
					new_trans[i][j][k] = MIN_PROB;

			}
		}
	}
	/*3 emissions*/
	for(int i =0; i < nr_snp; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{

			if(new_states[i][j].prob_em[0] < MIN_PROB)
				new_states[i][j].prob_em[0]  = MIN_PROB;
			if(new_states[i][j].prob_em[1] < MIN_PROB)
				new_states[i][j].prob_em[1]  = MIN_PROB;

		}
	}
/* renormalize*/
	/*1 normalize pi*/
	double total=0.0;
	for(int i =0; i< nr_founders; i++)
	{
		total += new_pi[i];
	}
	for(int i =0; i< nr_founders; i++)
	{
		new_pi[i] /= total;
	}
	/*2 normalize transitions*/			

	for(int i =0; i < nr_snp-1; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{
			total = 0.0;
			for(int k =0; k < nr_founders; k++)
			{
				total += new_trans[i][j][k];

			}
			for(int k =0; k < nr_founders; k++)
			{
				new_trans[i][j][k] /= total;
			}
		}
	}
	/*3 normalize emissions*/
	for(int i =0; i < nr_snp; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{
			total = new_states[i][j].prob_em[0] + new_states[i][j].prob_em[1];
			new_states[i][j].prob_em[0] /= total;
			new_states[i][j].prob_em[1] /= total;				
		}
	}
/* update HMM*/
	double is_modif = 0.0;
	double max_modif = 0.0;
	/*1 pi*/
	for(int i =0; i< nr_founders; i++)
	{
		if(fabs((*hmm).pi[i] - new_pi[i]) > max_modif)
			max_modif = fabs((*hmm).pi[i] - new_pi[i]);
		is_modif +=fabs((*hmm).pi[i] - new_pi[i]);		
		(*hmm).pi[i] = new_pi[i];
	}
	/*2 transitions*/			
	for(int i =0; i < nr_snp-1; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{
			for(int k =0; k < nr_founders; k++)
			{
				if(fabs((*hmm).trans[i][j][k] - new_trans[i][j][k])> max_modif)
					max_modif = fabs((*hmm).trans[i][j][k] - new_trans[i][j][k]);
				is_modif += fabs((*hmm).trans[i][j][k] - new_trans[i][j][k]);
				(*hmm).trans[i][j][k] = new_trans[i][j][k] ;
				
			}
		}
	}
	/*3 emissions*/
	for(int i =0; i < nr_snp; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{
			if(fabs((*hmm).states[i][j].prob_em[0] - new_states[i][j].prob_em[0])> max_modif)
					max_modif = fabs((*hmm).states[i][j].prob_em[0] - new_states[i][j].prob_em[0]);
			
			is_modif +=fabs((*hmm).states[i][j].prob_em[0] - new_states[i][j].prob_em[0]);
			(*hmm).states[i][j].prob_em[0] = new_states[i][j].prob_em[0];

			if(fabs((*hmm).states[i][j].prob_em[1] - new_states[i][j].prob_em[1])> max_modif)
					max_modif = fabs((*hmm).states[i][j].prob_em[1] - new_states[i][j].prob_em[1]);
			
			is_modif +=fabs((*hmm).states[i][j].prob_em[1] - new_states[i][j].prob_em[1]);
			(*hmm).states[i][j].prob_em[1] = new_states[i][j].prob_em[1];
		}
	}
	int nr_var;
	nr_var = nr_founders + (nr_snp-1)*nr_founders*nr_founders + 2*nr_founders*nr_snp;
	if(is_modif/nr_var > MIN_NR ) return true;
	return false;	
}
void alloc_mem_other()
{
	forward_hap_array = (double**)malloc(nr_snp*sizeof(double*));
	for(int i =0; i < nr_snp; i++)
	{
		forward_hap_array[i] = (double*)malloc(nr_founders*sizeof(double));
	}	
	backward_hap_array = (double**)malloc(nr_snp*sizeof(double*));
	for(int i =0; i < nr_snp; i++)
	{
		backward_hap_array[i] = (double*)malloc(nr_founders*sizeof(double));
	}
//Uno
	array_uno_precomp1 = (double**)malloc(nr_founders*sizeof(double*));
	for(int i =0; i< nr_founders; i++)
	{
		array_uno_precomp1[i] = (double*)malloc(nr_founders*sizeof(double));
	}

	totalProbUnoMatrix_forward = (double***)malloc(nr_snp*sizeof(double**)); 
	totalProbUnoMatrix_backward = (double***)malloc(nr_snp*sizeof(double**));
	totalProbUnoMatrix_unk = (double**)malloc(nr_snp*sizeof(double*));

	for(int i =0; i < nr_snp; i++)
	{
		totalProbUnoMatrix_forward[i] = (double**)malloc(nr_founders*sizeof(double*)); //Genotype Total
		totalProbUnoMatrix_backward[i] = (double**)malloc(nr_founders*sizeof(double*)); //Genotype Total
		totalProbUnoMatrix_unk[i] = (double*)malloc(nr_founders*sizeof(double)); //Genotype Total
		for(int j =0; j < nr_founders; j++)
		{
			totalProbUnoMatrix_forward[i][j] = (double*)malloc(nr_founders*sizeof(double)); //Genotype Total
			totalProbUnoMatrix_backward[i][j] = (double*)malloc(nr_founders*sizeof(double)); //Genotype Total
		}
	}
}
void alloc_mem_hmm(HAP_HMM *hmm)
{	
	hmm->states = (STATE**)malloc(nr_snp*sizeof(STATE*));
	for(int i =0; i < nr_snp; i++)
	{
		hmm->states[i] = (STATE*)malloc(nr_founders*sizeof(STATE));
	}
	hmm->pi = (double*)malloc(nr_founders*sizeof(double));
	hmm->pi_end = (double*)malloc(nr_founders*sizeof(double));
	hmm->trans = (double***)malloc((nr_snp-1)*sizeof(double**));
	for(int i =0; i < nr_snp-1; i++)
	{
		hmm->trans[i] = (double**)malloc(nr_founders*sizeof(double*));
		for(int j =0; j < nr_founders; j++)
		{
			hmm->trans[i][j] = (double*)malloc(nr_founders*sizeof(double));
		}
	}
}
void free_mem_other()
{
	for(int i =0; i < nr_snp; i++)
		free(forward_hap_array[i]);
	free(forward_hap_array);

	for(int i =0; i < nr_snp; i++)
		free(backward_hap_array[i]);
	free(backward_hap_array);
//Uno
	for(int i =0; i< nr_founders; i++)
		free(array_uno_precomp1[i]);
	free(array_uno_precomp1);

	for(int i =0; i < nr_snp; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{
			free(totalProbUnoMatrix_forward[i][j]);
			free(totalProbUnoMatrix_backward[i][j]);
		}
		free(totalProbUnoMatrix_forward[i]);
		free(totalProbUnoMatrix_backward[i]);
		free(totalProbUnoMatrix_unk[i]);
	}
	free(totalProbUnoMatrix_forward);
	free(totalProbUnoMatrix_backward);
	free(totalProbUnoMatrix_unk);
}
void free_mem_hmm(HAP_HMM *hmm)
{
	for(int i =0; i < nr_snp; i++)
		free(hmm->states[i]);
	free(hmm->states);
	free(hmm->pi);
	free(hmm->pi_end);
	for(int i =0; i < nr_snp-1; i++)
	{
		for(int j =0; j < nr_founders; j++)
			free(hmm->trans[i][j]);
		free(hmm->trans[i]);
	}
	free(hmm->trans);
}

int compute_allele_occurrences(int snp,char alelle,int h)
{
	int freq = 0;
	for(int j = 0; j < 2*anc_map[h].nr_genANC; j++)
	{
		if(anc_map[h].hap_array_ANC[j][snp] == alelle)
		{
			freq++;
		}
	}
	return freq;
}
void def_val_hmm(HAP_HMM *hmm, int h)
{
		double noise_dif = 0.0;
		for(int j = 0; j< nr_founders; j++)
		{
			hmm->pi[j] =  1/(double)nr_founders;
#if ADD_NOISE
			double p = pow(EPS, (unif_rand((long)(200*noise)) - 100.0*noise)/(double)100);
			noise_dif += fabs(hmm->pi[j] - hmm->pi[j] * p);
			hmm->pi[j] *= p;
#endif			
		}
		for(int j = 0; j< nr_founders; j++)
			hmm->pi_end[j] =  1/(double)nr_founders;
		/*set transition to 1/nr_founders for every trans*/	
		for(int i = 0; i< nr_snp-1; i++)
		{
			for(int j = 0; j< nr_founders; j++)
			{
				for(int k = 0; k< nr_founders; k++)
				{
					if(k==j)
					{
						hmm->trans[i][j][k] = founder_bias;
					}else
					{
						hmm->trans[i][j][k] = (1-founder_bias)/(double)(nr_founders-1);
					}
#if ADD_NOISE			
			double p = pow(EPS, (unif_rand((long)(200*noise)) - 100.0*noise)/(double)100);
			noise_dif += fabs(hmm->trans[i][j][k]  - hmm->trans[i][j][k]  * p);
			hmm->trans[i][j][k]  *= p;
#endif			
				}
			}
		}	
		/* set emission prob according to alele freq*/
		for(int i = 0; i< nr_snp; i++)
		{
			int num_0 = compute_allele_occurrences(i,'0',h) + 1;
			int num_1 = compute_allele_occurrences(i,'1',h) + 1;
#ifndef SAME_EM_PROB
			int tot = num_0 + num_1;
			for(int j = 0; j< nr_founders; j++)
			{
				if(unif_rand(tot) < num_0)
				{
					hmm->states[i][j].major = 0;
					hmm->states[i][j].prob_em[0] = MAJOR_PROB;
					hmm->states[i][j].prob_em[1] = 1 - MAJOR_PROB;					
				}else
				{
					hmm->states[i][j].major = 1;
					hmm->states[i][j].prob_em[0] = 1 - MAJOR_PROB;					
					hmm->states[i][j].prob_em[1] = MAJOR_PROB;
				}
			}
#endif
#ifdef SAME_EM_PROB
			if(num_0 == num_1)
			{
				for(int j = 0; j< nr_founders; j++)
					hmm->states[i][j].prob_em[0] = hmm->states[i][j].prob_em[1] = 0.5;
			}
			else
			{
				for(int j = 0; j< nr_founders; j++)
				{
					hmm->states[i][j].prob_em[0] = num_0/double(num_0+num_1) ;
					hmm->states[i][j].prob_em[1] = num_1/double(num_0+num_1) ;
				}	
			}
#endif		
#if ADD_NOISE	
			for(int j = 0; j< nr_founders; j++)
			{
					double p = pow(EPS, (unif_rand((long)(200*noise)) - 100.0*noise)/(double)100);
					noise_dif += fabs(hmm->states[i][j].prob_em[0]  - hmm->states[i][j].prob_em[0]  * p);
					hmm->states[i][j].prob_em[0] *= p;
					
					p = pow(EPS, (unif_rand((long)(200*noise)) - 100.0*noise)/(double)100);
					noise_dif += fabs(hmm->states[i][j].prob_em[1]  - hmm->states[i][j].prob_em[1]  * p);
					hmm->states[i][j].prob_em[1] *= p;
					
			}		
			
#endif			
		}
#if ADD_NOISE		
		/*if noise was added then renormalize*/	
	/*1 normalize pi*/
	double total=0.0;
	for(int i =0; i< nr_founders; i++)
	{
		total += hmm->pi[i];
	}
	for(int i =0; i< nr_founders; i++)
	{
		hmm->pi[i] /= total;

	}
	/*2 normalize transitions*/			

	for(int i =0; i < nr_snp-1; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{
			total = 0.0;
			for(int k =0; k < nr_founders; k++)
			{
				total += hmm->trans[i][j][k];

			}
			for(int k =0; k < nr_founders; k++)
			{
				hmm->trans[i][j][k] /= total;
			}
		}
	}
	/*3 normalize emissions*/
	for(int i =0; i < nr_snp; i++)
	{
		for(int j =0; j < nr_founders; j++)
		{
			total = hmm->states[i][j].prob_em[0] + hmm->states[i][j].prob_em[1];
			hmm->states[i][j].prob_em[0] /= total;
			hmm->states[i][j].prob_em[1] /= total;				
		}
	}
#endif						
}
void print_hmm_fileJLK(HAP_HMM hmm, FILE *fout)
{
	if(blocknum == 1)
		fprintf(fout,"HMM for SNPs %d to %d\n",0,nr_snp);
	else
		fprintf(fout,"HMM for SNPs %d to %d\n",(1+blocksize)*(blocknum-1)-(half_overlap)*(blocknum-1),(nr_snp+1+blocksize)*(blocknum-1)-(half_overlap)*(blocknum-1));
	fprintf(fout,"Nr founders = %d\n",nr_founders);
	fprintf(fout,"Nr snp = %d\n",nr_snp);
	fprintf(fout,"Founders bias = %.3f\n",founder_bias);
	fprintf(fout,"Perturbation = %.3f\n\n",noise);
	int currSNP;
	for(int j = 0; j < nr_snp; j++)
	{
		currSNP = ((j+1)+(blocksize)*(blocknum-1)-(half_overlap)*(blocknum-1)); //pass 1
		fprintf(fout,"%d emit ",currSNP); //position
		for(int f = 0; f < nr_founders; f++)
		{
			fprintf(fout,"%e ",hmm.states[j][f].prob_em[0]);
			fprintf(fout,"%e",hmm.states[j][f].prob_em[1]);
			for(int g = 0; g < nr_founders; g++)
			{
				fprintf(fout," ");
			}
		}
		fprintf(fout,"\n");
	}
	fprintf(fout,"initial trans: ");
	for(int j = 0; j<nr_founders; j++)
	{
		fprintf(fout,"%.3f ",hmm.pi[j]);
	}
	fprintf(fout,"\n");		
	for(int j = 0; j < nr_snp; j++)
	{
		currSNP = ((j+1)+(blocksize)*(blocknum-1)-(half_overlap)*(blocknum-1)); //pass 1
		if(j<(nr_snp -1))
		{
			fprintf(fout,"%d trans ",currSNP); //position
			for(int f = 0; f< nr_founders; f++)
			{
				for(int g = 0; g< nr_founders; g++)
				{	
					fprintf(fout,"%e ",hmm.trans[j][f][g]);
				}	
				fprintf(fout,"        ");
			}
			fprintf(fout,"\n");	
		}
	}
	fprintf(fout,"ending trans: ");
	for(int j = 0; j<nr_founders; j++)
	{
		fprintf(fout,"%.3f ",hmm.pi_end[j]);
	}
}
double forward(int a, int b, int j , int index_gen ,HAP_HMM hmm)
{
	double ret;
	if(j == 0)
	{
		ret = hmm.pi[a]*hmm.pi[b];
		double tt;
		if((gen_array[index_gen][j]== '0'))
		{
			tt = hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[0]; 
				
		}else
		if((gen_array[index_gen][j]== '2'))	
		{
			tt = 0.5*hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[1] 
					+ 0.5*hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0]
					;
		}else
		if((gen_array[index_gen][j]== '1'))
		{
			tt = hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[1]; 
		}else
//Modification 10/24/2006 JLK- Unknown '?' is the same as '3' so add '3'
		if((gen_array[index_gen][j]== '?')||(gen_array[index_gen][j]== '3'))
//		if((gen_array[index_gen][j]== '?'))
//End Modification 10/24/2006 JLK
		{
			tt = hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[0]+
				hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[1]+
				hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0]+
				hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[1];
			tt /= 4.0;	
		}else
		{
			fprintf(stderr,"ERROR forward gen_array[%d][%d]=%c not found\n\n", j,index_gen,gen_array[index_gen][j] );
			exit(0);
		}
		ret = ret*tt;
		return ret;
		
	}else
	{
		ret = 0.0;
		for(int prev_a = 0 ; prev_a < nr_founders; prev_a++)
		{
			for(int prev_b = 0 ; prev_b < nr_founders; prev_b++)
			{

				//double prob = hmm.trans[j-1][prev_a][a]*hmm.trans[j-1][prev_b][b]*forward(prev_a,prev_b,j-1,gen,hmm);
				double prob = hmm.trans[j-1][prev_a][a]*
							  hmm.trans[j-1][prev_b][b]*
							  forward_array[j-1][index_gen][prev_a][prev_b];
//PREVJLK		double tt;
				double tt = 0;
				if((gen_array[index_gen][j]=='0'))
				{
					tt = hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[0] ;
						
				}else
				if((gen_array[index_gen][j]=='2'))
				{
					tt = 0.5*hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[1] 
							+ 0.5*hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0] 
							;
				}else
				if((gen_array[index_gen][j]=='1'))
				{
					tt = hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[1];
						
				}else
//Modification 10/24/2006 JLK- Unknown '?' is the same as '3' so add '3'
				if((gen_array[index_gen][j]== '?')||(gen_array[index_gen][j]== '3'))
//				if((gen_array[index_gen][j]=='?'))
//End Modification 10/24/2006 JLK
				{
					tt = hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[0] +
					hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[1]+
					hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0]+
					hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[1];
					tt /=4.0;
						
				}else
				{
					fprintf(stderr,"ERROR forward gen_array[%d][%d]=%c not found\n\n", j,index_gen,gen_array[index_gen][j] );
					exit(0);
				}
				ret += prob*tt;
			}
		
		}
		return ret;
		
	}

}

double backward(int a, int b, int j , int index_gen ,HAP_HMM hmm)
{
	double ret;
	if(j == nr_snp-1 )
		return 1;
	else
	{
		ret = 0.0;
		for(int next_a = 0 ; next_a < nr_founders; next_a++)
		{
			for(int next_b = 0 ; next_b < nr_founders; next_b++)
			{
				double prob = hmm.trans[j][a][next_a]*
							  hmm.trans[j][b][next_b]*
							  backward_array[j+1][index_gen][next_a][next_b];
				double tt;
				if((gen_array[index_gen][j]=='0'))
				{
					tt = hmm.states[j+1][next_a].prob_em[0]*hmm.states[j+1][next_b].prob_em[0] ;
						
				}else
				if((gen_array[index_gen][j]=='2'))
				{
					tt = 0.5*hmm.states[j+1][next_a].prob_em[0]*hmm.states[j+1][next_b].prob_em[1] 
						+ 0.5*hmm.states[j+1][next_a].prob_em[1]*hmm.states[j+1][next_b].prob_em[0] 
							;
				}else
				if((gen_array[index_gen][j]=='1'))
				{
					tt = hmm.states[j+1][next_a].prob_em[1]*hmm.states[j+1][next_b].prob_em[1];
				}
				else
				if((gen_array[index_gen][j]== '?')||(gen_array[index_gen][j]== '3'))
				{
					tt = hmm.states[j+1][next_a].prob_em[0]*hmm.states[j+1][next_b].prob_em[0] +
						hmm.states[j+1][next_a].prob_em[0]*hmm.states[j+1][next_b].prob_em[1]+
						hmm.states[j+1][next_a].prob_em[1]*hmm.states[j+1][next_b].prob_em[0]+
						hmm.states[j+1][next_a].prob_em[1]*hmm.states[j+1][next_b].prob_em[1];
					tt /= 4.0	;
				}
				else
				{
					fprintf(stderr,"ERROR backward gen_array[%d][%d]=%c not found\n\n", j,index_gen,gen_array[index_gen][j] );
					return MIN_NR;
					exit(0);
				}
				ret += prob*tt;
			}
		}
		return ret;
	}
}

int convAlleleCharToInteger(char val)
{
	if(val == '0') return 0;
	else if (val == '1') return 1;
	else if (val == '2') return 2;
	else if (val == '3') return 3;
	else return 3;//unknown
}
int convAlleleIntegerToChar(int val)
{
	if(val == 0) return '0';
	else if (val == 1) return '1';
	else if (val == 2) return '2';
	else if (val == 3) return '3';
	else return '3';//unknown
}
double forward_hap(int a, int j , char* hap ,HAP_HMM hmm)
{
	double ret;
	if(j == 0)
	{
		ret = hmm.pi[a];
		if((hap[j]== '0')) ret *= hmm.states[j][a].prob_em[0]; 
		else if((hap[j]== '1'))	ret *= hmm.states[j][a].prob_em[1]; 
		else if((hap[j]== '?')||(hap[j]=='3'))ret *= 1.0;
		else
		{
			fprintf(stderr,"ERROR forward_hap hap[%d]=%c not found\n\n", j,hap[j] );
			exit(0);
		}
		return ret;
		
	}
	else
	{
		double tot = 0.0;
		for(int prev_a = 0 ; prev_a < nr_founders; prev_a++)
		{
				double prob = hmm.trans[j-1][prev_a][a] * forward_hap_array[j-1][prev_a];
				if((hap[j]== '0'))prob *= hmm.states[j][a].prob_em[0]; 
				else if((hap[j]== '1'))	prob *= hmm.states[j][a].prob_em[1]; 
				else if((hap[j]== '?')||(hap[j]=='3')) prob *=1.0;
				else
				{
					fprintf(stderr,"ERROR forward_hap hap[%d]=%c not found\n\n", j,hap[j] );
					exit(0);
				}
				tot += prob;			
		}
		return tot;
	}
}

double backward_hap(int a, int j , char* hap ,HAP_HMM hmm)
{

	if(j == nr_snp-1 ) return 1;
	else
	{
		double tot = 0.0;
		for(int next_a = 0 ; next_a < nr_founders; next_a++)
		{
				double prob = hmm.trans[j][a][next_a] * backward_hap_array[j+1][next_a];
				if((hap[j+1]== '0')) prob *= hmm.states[j+1][next_a].prob_em[0]; 
				else if((hap[j+1]== '1')) prob *= hmm.states[j+1][next_a].prob_em[1]; 
				else if((hap[j+1]== '?')||(hap[j+1]=='3')) prob *= 1.0;
				else
				{
					fprintf(stderr,"ERROR backward_hap hap[%d]=%c not found\n\n", j,hap[j] );
					exit(0);
				}
				tot += prob;			
		}
		return tot;
	}
}
void fill_forward_backward_hap_arrays(char* hap ,HAP_HMM hmm)
{
	for(int i =0 ;i<nr_snp;i++)
	{
		for(int a = 0 ; a < nr_founders; a++)
		{
			forward_hap_array[i][a] = forward_hap( a, i , hap , hmm);
		}
	}
	for(int i =nr_snp-1 ;i>=0;i--)
	{
		for(int a = 0 ; a < nr_founders; a++)
		{
			backward_hap_array[i][a] = backward_hap( a, i , hap , hmm);
		}
	}
}

double calcEmissionProbMax(int g1, int g2, char ch,int j, HAP_HMM hmmOne, HAP_HMM hmmTwo)
//given the genotype at location SNP j, find the hmm probability
//that it will emit a compatible set of characters, at the states of the 2 paths g1,g2
{
	double maxVal = 0;
	double currentVal = 0;
	double g10 = hmmOne.states[j][g1].prob_em[0];
	double g11 = hmmOne.states[j][g1].prob_em[1];
	double g20;
	double g21;
	g20 = hmmTwo.states[j][g2].prob_em[0];
	g21 = hmmTwo.states[j][g2].prob_em[1];
	int chi = convAlleleCharToInteger(ch);

	currentVal = g10*g20;
	if (((chi==0)||(chi==3))&&(currentVal>maxVal))
		maxVal = currentVal;
	currentVal = g10*g21;
	if (((chi==2)||(chi==3))&&(currentVal>maxVal))
		maxVal = currentVal;
	currentVal = g11*g20;
	if (((chi==2)||(chi==3))&&(currentVal>maxVal))
		maxVal = currentVal;
	currentVal = g11*g21;
	if (((chi==1)||(chi==3))&&(currentVal>maxVal))
		maxVal = currentVal;
	return maxVal;
}
double totalAllele0ProbAt(HAP_HMM hmm, int j)
//Allele frequency calculation at a certain SNP
{
	double sumProbs = 0;
	for(int f = 0; f< nr_founders; f++)
		sumProbs+= hmm.states[j][f].prob_em[0]; 
	return (sumProbs/(double)nr_founders);
}
double totalProbUno_forward_fast(char* ch, HAP_HMM hmmOne, HAP_HMM hmmTwo)
//Genotype Total...Given the input haplotype and data hidden markov model, compute the summed probability that this haplotype will be emitted
{
	double ret = 0.0;
	int chi;
	for (int j = 0; j < nr_snp;j++)
	{
		chi = convAlleleCharToInteger(ch[j]);
		for (int a =0; a< nr_founders;a++)
		{
			if(j>0)
			{	
				for (int b =0; b< nr_founders;b++)
					array_uno_precomp1[a][b] = preCompute_total_uno1_forward(a,b,j,hmmOne);
			}
			for (int b =0; b< nr_founders;b++)
			{
			 	totalProbUnoMatrix_forward[j][a][b] = totalProbUnoAt_forward_fast(a,b,j,chi,hmmOne,hmmTwo);
				if (j == nr_snp-1) 
					ret+=totalProbUnoMatrix_forward[j][a][b]*hmmOne.pi_end[a]*hmmTwo.pi_end[b];
			}
		}
	}
	return log10(ret);
}
double totalProbUno_forward_fast(char* ch, HAP_HMM hmmOne, HAP_HMM hmmTwo, int iStart, int iEnd)
//Genotype Total...Given the input haplotype and data hidden markov model, compute the summed probability that this haplotype will be emitted
{
	double ret = 0.0;
	int chi;
	for (int j = iStart; ((j <= iEnd) && (j < nr_snp));j++)
	{
		chi = convAlleleCharToInteger(ch[j]);
		for (int a =0; a< nr_founders;a++)
		{
			if(j>0)
			{	
				for (int b =0; b< nr_founders;b++)
					array_uno_precomp1[a][b] = preCompute_total_uno1_forward(a,b,j,hmmOne);
			}
			for (int b =0; b< nr_founders;b++)
			{
			 	totalProbUnoMatrix_forward[j][a][b] = totalProbUnoAt_forward_fast(a,b,j,chi,hmmOne,hmmTwo);
				if (j == nr_snp-1) ret+=totalProbUnoMatrix_forward[j][a][b]*hmmOne.pi_end[a]*hmmTwo.pi_end[b];
			}
		}
	}
	return log10(ret);
}
double totalProb(char* gen, HAP_HMM hmm)
//Genotype Total...Given the input haplotype and data hidden markov model, compute the summed probability that this haplotype will be emitted
{
	double ret = 0.0;
	int gi;
	for (int j = 0; j < nr_snp;j++)
	{
		gi = convAlleleCharToInteger(gen[j]);
		for (int a =0; a< nr_founders;a++)
		{
			for(int b = 0; b < nr_founders; b++)
			{
				totalProbMatrix[j][a][b] = totalProbAt(a,b,j,gi,hmm);
				if (j == nr_snp-1) 
					ret+=totalProbMatrix[j][a][b]*hmm.pi_end[a]*hmm.pi_end[b];
			}
		}
	}
	return log10(ret);

}
double totalProbUnoAt_unk(int a, int b, int j, int chi, HAP_HMM hmmTwo)
{
	double ret = 0;
	for(int prev_b= 0; prev_b < nr_founders; prev_b++)
	{
		ret+= array_uno_precomp1[a][prev_b]*hmmTwo.trans[j][prev_b][b];
	}
	return ret*totalProbUnoMatrix_backward[j+1][a][b];
}
double totalProbUno_unk(char* ch, HAP_HMM hmmOne, HAP_HMM hmmTwo, int j)
{
	double ret = 0;
	int chi = convAlleleCharToInteger(ch[j]);
	
	if(j>0)
	{
		for (int a =0; a< nr_founders;a++)
		{
			for (int b =0; b< nr_founders;b++)
				array_uno_precomp1[a][b] = preCompute_total_uno1_forward(a,b,j,hmmOne);
			for (int b =0; b< nr_founders;b++)
			{
			 	totalProbUnoMatrix_unk[a][b] = totalProbUnoAt_forward_fast(a,b,j,chi,hmmOne,hmmTwo);
				if(j == nr_snp - 1)
				{
				 	 ret+=totalProbUnoMatrix_unk[a][b]*hmmOne.pi_end[a]*hmmTwo.pi_end[b];
				}
			}
		}
		if(j<(nr_snp-1))
		{
			ret = 0;
			chi = convAlleleCharToInteger(ch[j+1]);
			for (int a =0; a< nr_founders;a++)
			{
				for (int b =0; b< nr_founders;b++)
				{
					for (int c =0; c< nr_founders;c++)
						if(j>0) array_uno_precomp1[a][b] = preCompute_total_uno1_unk(a,b,j+1,hmmOne);
				}
				for (int b=0; b< nr_founders;b++)
					ret+= totalProbUnoAt_unk(a,b,j,chi,hmmTwo);
			}
		}
	}
	else
	{
		for (int a =0; a< nr_founders;a++)
		{
			for (int b =0; b< nr_founders;b++)
			{
			 	array_uno_precomp1[a][b] = preCompute_total_uno1_backward(a,b,j,hmmOne);
			}
			for (int b=0; b< nr_founders;b++)
			{	
				totalProbUnoMatrix_unk[a][b] = totalProbUnoAt_backward_fast(a,b,j,chi,hmmOne,hmmTwo);
				ret+=totalProbUnoMatrix_unk[a][b]*hmmOne.pi[a]*hmmTwo.pi[b];
			}
		}
	}
	return log10(ret);
}
double totalProbUno_backward_fast(char* ch, HAP_HMM hmmOne, HAP_HMM hmmTwo)
//Genotype Total...Given the input haplotype and data hidden markov model, compute the summed probability that this haplotype set will be emitted
{
	double ret = 0;
	int chi;
	for (int j = (nr_snp-1); j >= 0;j--)
	{
		chi = convAlleleCharToInteger(ch[j]);
		for (int a =0; a< nr_founders;a++)
		{
			if(j<(nr_snp-1))
			{	
				for (int b =0; b< nr_founders;b++)
					array_uno_precomp1[a][b] = preCompute_total_uno1_backward(a,b,j,hmmOne);
			}
			for (int b =0; b< nr_founders;b++)
			{
			 	totalProbUnoMatrix_backward[j][a][b] = totalProbUnoAt_backward_fast(a,b,j,chi,hmmOne, hmmTwo);
				if (j == 0) 
					ret+=totalProbUnoMatrix_backward[j][a][b]*hmmOne.pi[a]*hmmTwo.pi[b];
			}

		}
	}
	return log10(ret);
}
double totalProbUno_backward_fast(char* ch, HAP_HMM hmmOne, HAP_HMM hmmTwo,int iStart, int iEnd)
//Genotype Total...Given the input haplotype and data hidden markov model, compute the summed probability that this haplotype set will be emitted
{
	double ret = 0;
	int chi;
	for (int j = iStart; j >= iEnd; j--)
	{
		chi = convAlleleCharToInteger(ch[j]);
		for (int a =0; a< nr_founders;a++)
		{
			if(j<(nr_snp-1))
			{	
				for (int b =0; b< nr_founders;b++)
					array_uno_precomp1[a][b] = preCompute_total_uno1_backward(a,b,j,hmmOne);
			}
			for (int b =0; b< nr_founders;b++)
			{
			 	totalProbUnoMatrix_backward[j][a][b] = totalProbUnoAt_backward_fast(a,b,j,chi,hmmOne, hmmTwo);
				if (j == 0) ret+=totalProbUnoMatrix_backward[j][a][b]*hmmOne.pi[a]*hmmTwo.pi[b];
			}

		}
	}
	return log10(ret);
}
double preCompute_total_uno1_forward(int a, int bpr, int j , HAP_HMM hmm)
{
	double ret = 0;
	for(int prev_a = 0 ; prev_a < nr_founders; prev_a++)
		ret += totalProbUnoMatrix_forward[j-1][prev_a][bpr]*hmm.trans[j-1][prev_a][a];
	return ret;
}
double preCompute_total_uno1_unk(int a, int bpr, int j , HAP_HMM hmm)
{
	double ret = 0;
	for(int prev_a = 0 ; prev_a < nr_founders; prev_a++)
		ret+=totalProbUnoMatrix_unk[prev_a][bpr]*hmm.trans[j-1][prev_a][a];
	return ret;
}
double totalProbUnoAt_forward_fast(int a, int b, int j, int chi, HAP_HMM hmmOne, HAP_HMM hmmTwo)
{
	double ret = 0;
	double ep = calcEmissionProbMax(a,b,convAlleleIntegerToChar(chi),j,hmmOne,hmmTwo);
	if(j == 0) 
	{
		ret = hmmOne.pi[a]*hmmTwo.pi[b]*ep;		
		return ret;
	}
	else
	{
		for(int prev_b = 0 ; prev_b < nr_founders; prev_b++)
			ret+= array_uno_precomp1[a][prev_b]*hmmTwo.trans[j-1][prev_b][b];
		return ret*ep;
	}
}
double totalProbAt(int a, int b, int j, int gi, HAP_HMM hmm)
{
	double ret = 0.0;
	double ep;
	if(gi == 0)
	{
		ep = hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[0]; 
	}
	else if(gi == 2)	
	{
		ep = hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[1];
		if(ep < (hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0]))
			ep = hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0];
	}
	else if(gi == 1)
	{
		ep = hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[1]; 
	}
	else if(gi==3)
	{
		ep = hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[0];
		if(ep <= (hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[1]))
			ep = (hmm.states[j][a].prob_em[0]*hmm.states[j][b].prob_em[1]);
		if(ep <= (hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0]))
			ep = (hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[0]);
		if(ep <= (hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[1]))
			ep = (hmm.states[j][a].prob_em[1]*hmm.states[j][b].prob_em[1]);
	}
	else
	{
		fprintf(stderr,"ERROR totalProbAt gen[%d]=%d not found\n\n", j,gi );
		exit(0);
	}
	if(j == 0) 
	{
		ret = hmm.pi[a]*hmm.pi[b]*ep;		
		return ret;
	}
	else
	{
		for(int prev_a = 0 ; prev_a < nr_founders; prev_a++)
			for(int prev_b = 0 ; prev_b < nr_founders; prev_b++)
				ret+= totalProbMatrix[j-1][prev_a][prev_b]*hmm.trans[j-1][prev_a][a]*hmm.trans[j-1][prev_b][b];
		return ret*ep;
	}
}
double preCompute_total_uno1_backward(int a, int bpr, int j , HAP_HMM hmm)
{
	double ret = 0;
	for(int prev_a = 0 ; prev_a < nr_founders; prev_a++)
		ret += totalProbUnoMatrix_backward[j+1][prev_a][bpr]*hmm.trans[j][a][prev_a];
	return ret;
}
double totalProbUnoAt_backward_fast(int a, int b, int j, int chi, HAP_HMM hmmOne, HAP_HMM hmmTwo)
{
	double ret = 0;
	double ep = calcEmissionProbMax(a,b,convAlleleIntegerToChar(chi),j,hmmOne, hmmTwo);
	if(j == (nr_snp-1)) return hmmOne.pi_end[a]*hmmTwo.pi_end[b]*ep;		
	else
	{
		for(int prev_b = 0 ; prev_b < nr_founders; prev_b++)
			ret+= array_uno_precomp1[a][prev_b]*hmmTwo.trans[j][b][prev_b];
		return ret*ep;
	}
}
bool existsInOrderedArrayLimit(int index,int numElements)
//Scan the ordered array to find if the index parm 
//is in the ordered array
{
	for(int i = 0; i < numElements;i++)
		if(orderOfProcessing[i]==index) return true;
	return false;
}
void generateOrdering()
//given the input of arbitrary pedigree structure, 
//Create the list of IDs used in top down ordering of processing
{
	bHasPedigree = false;
	orderOfProcessing = (int*)malloc(nr_gen_to_estimate*sizeof(int));
	if(nr_gen_to_estimate == 1)
	{
		orderOfProcessing[0] = 0;
		return;
	}
	for(int i = 0; i < nr_gen_to_estimate;i++)
	{
		orderOfProcessing[i] = -1;
	}
	int boundNum = 0; 
	int usableIndex = 0;
	while (usableIndex < nr_gen_to_estimate)
	{
 	 	boundNum++;
		for(int i = 0; i < nr_gen_to_estimate;i++)
		{
			if(!existsInOrderedArrayLimit(i,usableIndex))
				orderOfProcessing[usableIndex++]= i;
		}
		if(boundNum>=nr_gen_to_estimate)
		{
			for(int i = 0; i < nr_gen_to_estimate;i++)
			{
				fprintf(stderr,"Order: %d\n",orderOfProcessing[i]);
			}
		    printf("error in input- please check your input files\n");
		    exit(0);
		}
	}
	return;
}

int getJStart()
{
	if(startLocGlobal == 0)        
//	if(blocknum == 1)        
	{        
        	return 0;        
	}        
	else
	{           
    		return half_overlap/2;        
	}      
}

int getJEnd()
{
	//int currJTest = (nr_snp)+(blocksize)*(blocknum-1)-(half_overlap)*(blocknum-1);
	int currJTest = getEndLocGlobal();
	if(currJTest > (totalSNPSize-1))
    {
		return nr_snp;
	}
	else
	{
		 return nr_snp - half_overlap/2 ;
	}
}
double **** unic0Matrix;
double **** unic1Matrix;
double **** unic2Matrix;
void runAdmixedComputations(int h1,int h2) //block format for admixed output
{
    int jStart = getJStart();
    int jEnd = getJEnd();
	char oldChar;
	for(int i = 0; i < nr_gen_to_estimate; i++)
	{
		int currInd = orderOfProcessing[i];
		int currid = gen_indiv_id[currInd];
/*Population 1,2*/
		double totalProbValForwardUnicP1P2 = totalProbUno_forward_fast(gen_to_est_array[currInd],anc_map[h1].hmm,anc_map[h2].hmm,0,jEnd); //This is what I'm trying to speed up...
		double totalProbValBackwardUnicP1P2 = totalProbUno_backward_fast(gen_to_est_array[currInd],anc_map[h1].hmm,anc_map[h2].hmm,nr_snp - 1,jStart);
		for(int j = jStart; j <jEnd; j++)
		{
			oldChar = gen_to_est_array[currInd][j];            
			gen_to_est_array[currInd][j] = '2';
			unic2Matrix[h1][h2][i][j] = totalProbUno_unk(gen_to_est_array[currInd],anc_map[h1].hmm,anc_map[h2].hmm,j);
			gen_to_est_array[currInd][j] = '1';              
			unic1Matrix[h1][h2][i][j] = totalProbUno_unk(gen_to_est_array[currInd],anc_map[h1].hmm,anc_map[h2].hmm,j);
			gen_to_est_array[currInd][j] = '0';
			unic0Matrix[h1][h2][i][j] = totalProbUno_unk(gen_to_est_array[currInd],anc_map[h1].hmm,anc_map[h2].hmm,j);
			gen_to_est_array[currInd][j] = oldChar;
		}
	}
}
void runImputation() //replaces all untyped/completely missing SNPs in the genotype data with imputed genotypes
{
	int j = currKSNPLocal;
	char oldChar;
	double currProb;
	double bestProb;
	char bestVal; //0,1,or 2
	for(int i = 0; i < nr_gen_to_estimate; i++)
	{
		int currInd = orderOfProcessing[i];
		int currid = gen_indiv_id[currInd];
		bestProb = -99999.9;
		bestVal = '?';
		oldChar = gen_to_est_array[currInd][j];    
		double totalProbValForwardUnicP1P2 = totalProbUno_forward_fast(gen_to_est_array[currInd],anc_map[anc1_call[i][currKSNPGlobal]].hmm,anc_map[anc2_call[i][currKSNPGlobal]].hmm,0,j); 
		double totalProbValBackwardUnicP1P2 = totalProbUno_backward_fast(gen_to_est_array[currInd],anc_map[anc1_call[i][currKSNPGlobal]].hmm,anc_map[anc2_call[i][currKSNPGlobal]].hmm,nr_snp - 1,j);
		gen_to_est_array[currInd][j] = '0';
		currProb = totalProbUno_unk(gen_to_est_array[currInd],anc_map[anc1_call[i][currKSNPGlobal]].hmm,anc_map[anc2_call[i][currKSNPGlobal]].hmm,j);
		ap_0[anc1_call[i][currKSNPGlobal]][anc2_call[i][currKSNPGlobal]][i][currKSNPGlobal] = pow(10.0,currProb);
		if(currProb > bestProb)
		{
			bestProb = currProb;
			bestVal = '0';
		}
		gen_to_est_array[currInd][j] = '1';              
		currProb= totalProbUno_unk(gen_to_est_array[currInd],anc_map[anc1_call[i][currKSNPGlobal]].hmm,anc_map[anc2_call[i][currKSNPGlobal]].hmm,j);
		ap_1[anc1_call[i][currKSNPGlobal]][anc2_call[i][currKSNPGlobal]][i][currKSNPGlobal] = pow(10.0,currProb);
		if(currProb > bestProb)
		{
			bestProb = currProb;
			bestVal = '1';
		}
		gen_to_est_array[currInd][j] = '2';
		currProb = totalProbUno_unk(gen_to_est_array[currInd],anc_map[anc1_call[i][currKSNPGlobal]].hmm,anc_map[anc2_call[i][currKSNPGlobal]].hmm,j);
		ap_2[anc1_call[i][currKSNPGlobal]][anc2_call[i][currKSNPGlobal]][i][currKSNPGlobal] = pow(10.0,currProb);
		if(currProb > bestProb)
		{
			bestProb = currProb;
			bestVal = '2';
		}
		gen_to_est_array[currInd][j] = oldChar;            
		gen_to_est_array[currInd][j] = bestVal;
		gen_to_est_array_full[currInd][currKSNPGlobal] = bestVal;
	}//end currInd Loop
}
void runAdmixed()
{
	unic0Matrix = (double****)malloc(hmmCount*sizeof(double***));
	unic1Matrix = (double****)malloc(hmmCount*sizeof(double***));
	unic2Matrix = (double****)malloc(hmmCount*sizeof(double***));
	for(int h1 = 0; h1 < hmmCount; h1++)
	{
		unic0Matrix[h1] = (double***)malloc(hmmCount*sizeof(double**));
		unic1Matrix[h1] = (double***)malloc(hmmCount*sizeof(double**));
		unic2Matrix[h1] = (double***)malloc(hmmCount*sizeof(double**));
		for(int h2 = h1; h2 < hmmCount; h2++)
		{
			unic0Matrix[h1][h2] = (double**)malloc(nr_gen_to_estimate*sizeof(double*));
			unic1Matrix[h1][h2] = (double**)malloc(nr_gen_to_estimate*sizeof(double*));
			unic2Matrix[h1][h2] = (double**)malloc(nr_gen_to_estimate*sizeof(double*));
			for(int i = 0; i < nr_gen_to_estimate; i++)
			{
				unic0Matrix[h1][h2][i] = (double*)malloc(nr_snp*sizeof(double));
				unic1Matrix[h1][h2][i] = (double*)malloc(nr_snp*sizeof(double));
				unic2Matrix[h1][h2][i] = (double*)malloc(nr_snp*sizeof(double));
			}
		}
	}
	for(int h1 = 0; h1 < hmmCount; h1++)
		for(int h2 = h1; h2 < hmmCount; h2++)
			runAdmixedComputations(h1,h2);
	int jStart = getJStart();
	int jEnd = getJEnd();
	for(int i = 0; i < nr_gen_to_estimate; i++)
	{
		int currInd = orderOfProcessing[i];
		int currid = gen_indiv_id[currInd];
		for(int j = jStart; j <jEnd; j++)
		{         
			int currSNP = getGlobalSNP(j); //pass 1
			for(int h1 = 0; h1 < hmmCount; h1++)
				for(int h2 = h1; h2 < hmmCount; h2++)
				{
					ap_0[h1][h2][i][currSNP] = pow(10.0,unic0Matrix[h1][h2][i][j]);
					ap_1[h1][h2][i][currSNP] = pow(10.0,unic1Matrix[h1][h2][i][j]);
					ap_2[h1][h2][i][currSNP] = pow(10.0,unic2Matrix[h1][h2][i][j]);
				}
		}
	}

	for(int h1 = 0; h1 < hmmCount; h1++)
	{
		for(int h2 = h1; h2 < hmmCount; h2++)
		{
			for(int i = 0; i < nr_gen_to_estimate; i++)
			{
				free(unic0Matrix[h1][h2][i]);
				free(unic1Matrix[h1][h2][i]);
				free(unic2Matrix[h1][h2][i]);
			}
			free(unic0Matrix[h1][h2]);
			free(unic1Matrix[h1][h2]); 
			free(unic2Matrix[h1][h2]); 
		}
		free(unic0Matrix[h1]);
		free(unic1Matrix[h1]); 
		free(unic2Matrix[h1]);
	}
	free(unic0Matrix);
	free(unic1Matrix);
	free(unic2Matrix);
}
void runGEDI()
{
	if(currPass == 1) //Admixed
	{
		runAdmixed();
	}
	else if(currPass == 2) //Imputation
	{
		runImputation();
	}
	return;
}
double getMinInitDenom(int h)//set numerator=denominator so transitions are 1 probability for initialization
{
	if(nr_founders > 1) return (nr_founders-1.0);
	else return TRANSITION_PSEUDOCOUNT*2*anc_map[h].nr_genANC;
}
void trainHMM(int h)
{
	def_val_hmm(&anc_map[h].hmm,h);
	double *pi_temp;
	pi_temp = (double*) malloc (nr_founders*sizeof(double));
	double*** trans_temp;
	trans_temp = (double***)malloc((nr_snp-1)*sizeof(double**));
	for(int i =0; i < nr_snp-1; i++)
	{
 		trans_temp[i] = (double**)malloc(nr_founders*sizeof(double*));
		for(int j =0; j < nr_founders; j++)
		{
		 		trans_temp[i][j] = (double*)malloc(nr_founders*sizeof(double));
		}
	}
	STATE**	states_temp;
	states_temp = (STATE**)malloc(nr_snp*sizeof(STATE*));
	for(int i =0; i < nr_snp; i++)
	{
 		states_temp[i] = (STATE*)malloc(nr_founders*sizeof(STATE));
	}
	bool cont = true;
	int step =0;
	double prev_prob=- 1/MIN_NR;
	while (cont)
	{	
		/*initialize temp structures*/
		for(int i =0; i < nr_founders; i++)
			pi_temp[i] = TRANSITION_PSEUDOCOUNT*2*anc_map[h].nr_genANC/getMinInitDenom(h); /* don't let any prob get 0*/
		for(int i =0; i < nr_snp-1; i++)
			for(int j =0; j < nr_founders; j++)
				for(int k =0; k < nr_founders; k++)
					trans_temp[i][j][k] = TRANSITION_PSEUDOCOUNT*2*anc_map[h].nr_genANC/getMinInitDenom(h); /* don't let any prob get 0*/
		for(int i =0; i < nr_snp; i++)
			for(int j =0; j < nr_founders; j++)
			{
		 		states_temp[i][j].prob_em[0] = EMISSION_PSEUDOCOUNT*2*anc_map[h].nr_genANC/nr_founders; /* don't let any prob get 0*/
	 			states_temp[i][j].prob_em[1] = EMISSION_PSEUDOCOUNT*2*anc_map[h].nr_genANC/nr_founders; /* don't let any prob get 0*/
			}
		double tot_prob = 0.0;
		double p_paths= 0.0;
		double p_haps= 0.0;
		double prob_of_hap;
		// use baum-welch training
		tot_prob = 0.0;
		for(int index_hap=0;  index_hap < 2*anc_map[h].nr_genANC;index_hap++)
		{
 			//compute forward_backward
			fill_forward_backward_hap_arrays(anc_map[h].hap_array_ANC[index_hap] , anc_map[h].hmm);
			//compute prob of hap
			prob_of_hap=0.0;
			for(int i = 0 ; i < nr_founders; i++)
				prob_of_hap += forward_hap_array[nr_snp-1][i];		
			tot_prob += log(prob_of_hap);
			for(int t = 0 ; t < nr_snp-1; t++)
			{
		 		//update trans_temp
		 		for(int i = 0 ; i < nr_founders; i++)
				{
					for(int j = 0 ; j < nr_founders; j++)
					{
				   		if(forward_hap_array[t][i] *
							anc_map[h].hmm.trans[t][i][j] *
							anc_map[h].hmm.states[t+1][j].prob_em[ anc_map[h].hap_array_ANC[index_hap][t+1]-48 ]*
							backward_hap_array[t+1][j] / prob_of_hap < MIN_NR)
						{
							 fprintf(stderr,"ERROWRRRRRRRR!!! %e %e\n",MIN_NR, forward_hap_array[t][i] *
								anc_map[h].hmm.trans[t][i][j] *
								anc_map[h].hmm.states[t+1][j].prob_em[ anc_map[h].hap_array_ANC[index_hap][t+1]-48 ]*
								backward_hap_array[t+1][j] / prob_of_hap);
						}					
						trans_temp[t][i][j] += forward_hap_array[t][i] *
							anc_map[h].hmm.trans[t][i][j] *
							anc_map[h].hmm.states[t+1][j].prob_em[ anc_map[h].hap_array_ANC[index_hap][t+1]-48 ]*
							backward_hap_array[t+1][j] / prob_of_hap ;
					}
				}
	 		}
			for(int t = 0 ; t < nr_snp; t++)		
				for(int i =0; i < nr_founders; i++)
					states_temp[t][i].prob_em[ anc_map[h].hap_array_ANC[index_hap][t]-48 ] += forward_hap_array[t][i] * backward_hap_array[t][i] / prob_of_hap;
			for(int i =0; i < nr_founders; i++)
				pi_temp[i] += anc_map[h].hmm.states[0][i].prob_em[ anc_map[h].hap_array_ANC[index_hap][0]-48 ]*backward_hap_array[0][i] / prob_of_hap;
		}
		//end training
/*make all temp structures probabilities and update hmm*/
/*1 normalize pi*/
		double total=0.0;
		for(int i =0; i< nr_founders; i++)
			total += pi_temp[i];
		for(int i =0; i< nr_founders; i++)
			pi_temp[i] /= total;
		/*2 normalize transitions*/			
		for(int i =0; i < nr_snp-1; i++)
			for(int j =0; j < nr_founders; j++)
			{
				total = 0.0;
				for(int k =0; k < nr_founders; k++)
					total += trans_temp[i][j][k];
				for(int k =0; k < nr_founders; k++)
					trans_temp[i][j][k] /= total;
			}
/*3 normalize emissions*/
		for(int i =0; i < nr_snp; i++)
			for(int j =0; j < nr_founders; j++)
			{
				total = states_temp[i][j].prob_em[0] + states_temp[i][j].prob_em[1];
				states_temp[i][j].prob_em[0] /= total;
				states_temp[i][j].prob_em[1] /= total;				
			}
		cont = update_hmm(&anc_map[h].hmm,pi_temp,states_temp,trans_temp);	
		step++;
		if(step == max_steps)
			cont = false;
		//Baum Welch stopping condition
		//fprintf(stderr,"Percentage increase %f\n", 1 - tot_prob/prev_prob);
		if( 1 - tot_prob/prev_prob < 0.001)
			cont = false;
		prev_prob = tot_prob;	
	}//end training
	free(pi_temp);
	for(int i =0; i < nr_snp-1; i++)
	{
		for(int j =0; j < nr_founders; j++)
		 	free(trans_temp[i][j]);
 		free(trans_temp[i]);
	}
	free(trans_temp);
	for(int i =0; i < nr_snp; i++)
 		free(states_temp[i]);
	free(states_temp);
}
bool runPass2() //impute SNP data (2*k+1-Window HMM)
{
	fprintf(stderr,"BEGIN PASS 2(Imputation)\n");
	currKSNPGlobal = -1;
	currKSNPGlobal = getNextKLoc();
	while(currKSNPGlobal>=0)
	{
		setKData();
		alloc_mem_other();
		fprintf(stderr,"Imputing SNP %d - ",(currKSNPGlobal + 1));
		double startTimeGEDI = (double)clock();
		for(int h = 0; h < hmmCount; h++)
		{
			trainHMM(h);
		}
		#if defined(_WIN32) || defined(_WIN64)
			fprintf(stderr," training %f sec, ",(((double)clock()-startTimeGEDI)/1000));
			trainingTime+= ((double)clock()-startTimeGEDI)/1000;
		#else
			fprintf(stderr," training %f sec, ",(((double)clock()-startTimeGEDI)/1000000));
			trainingTime+= ((double)clock()-startTimeGEDI)/1000000;
		#endif
		startTimeGEDI = (double)clock();
 		runGEDI();
		#if defined(_WIN32) || defined(_WIN64)
			fprintf(stderr," computations %f sec\n",(((double)clock()-startTimeGEDI)/1000));
		#else
			fprintf(stderr," computations %f sec\n",(((double)clock()-startTimeGEDI)/1000000));
		#endif
		free_mem_other();
		freeKData();
		currKSNPGlobal = getNextKLoc();
	}
	fprintf(stderr,"END PASS 2\n");
	return true;
}
void initAncestryInference()
{
	ap_0 = (double****)calloc(hmmCount,sizeof(double***));
	ap_1 = (double****)calloc(hmmCount,sizeof(double***));
	ap_2 = (double****)calloc(hmmCount,sizeof(double***));
	for(int h1 = 0; h1 < hmmCount; h1++)
	{
		ap_0[h1] = (double***)calloc(hmmCount,sizeof(double**));
		ap_1[h1] = (double***)calloc(hmmCount,sizeof(double**));
		ap_2[h1] = (double***)calloc(hmmCount,sizeof(double**));
		for(int h2 = h1; h2 < hmmCount; h2++)
		{
			ap_0[h1][h2] = (double**)calloc(nr_gen_to_estimate,sizeof(double*));
			ap_1[h1][h2] = (double**)calloc(nr_gen_to_estimate,sizeof(double*));
			ap_2[h1][h2] = (double**)calloc(nr_gen_to_estimate,sizeof(double*));
			for(int i =0; i < nr_gen_to_estimate;i++)
			{
				ap_0[h1][h2][i] = (double*)calloc(totalSNPSize,sizeof(double));
				ap_1[h1][h2][i] = (double*)calloc(totalSNPSize,sizeof(double));
				ap_2[h1][h2][i] = (double*)calloc(totalSNPSize,sizeof(double));
				for(int j = 0; j < totalSNPSize; j++)
				{
					ap_0[h1][h2][i][j] = -1.0;
					ap_1[h1][h2][i][j] = -1.0;
					ap_2[h1][h2][i][j] = -1.0;
				}
			}
		}
	}
	true_gen = (int**)calloc(nr_gen_to_estimate,sizeof(int*));
	for(int i =0; i < nr_gen_to_estimate;i++)
	{
		true_gen[i] = (int*)calloc(totalSNPSize,sizeof(int));
		for(int j = 0; j < totalSNPSize; j++)
		{
			true_gen[i][j] = convAlleleCharToInteger(gen_to_est_array_full[i][j]);
		}
	}
}
void computeAncestryInference()
{
	double ***probMatrix;
	double ** anc_score;
	double ** anc_score_win;
	double ap_tot;
	double prev_tot;
	double a0Val;
	double a1Val;
	double a2Val;
	double tot;
	fprintf(stderr,"\nRunning Ancestry Inference Computations\n");
	fprintf(stderr,"Sorting SNPs by position...");
	qsort(snp_map, nr_hsnp, sizeof(struct SNP),comp_snp_pos);
	fprintf(stderr,"done\n");

	fprintf(stderr,"Sorting pedigree map...");
	qsort(ped_map, nr_samples, sizeof(struct PED),comp_ped_map_pos);
	fprintf(stderr,"done\n");

	probMatrix =  (double***)calloc(totalSNPSize+2,sizeof(double**));	
	for(int j =0; j < totalSNPSize+2; j++)
	{
		probMatrix[j] =  (double**)calloc(hmmCount,sizeof(double*));	
		for(int h1 = 0; h1 < hmmCount; h1++)
		{
			probMatrix[j][h1] =  (double*)calloc(hmmCount,sizeof(double));	
		}
	}
	anc_score = (double**)calloc(hmmCount,sizeof(double*));	
	anc_score_win = (double**)calloc(hmmCount,sizeof(double*));
	for(int h1 = 0; h1 < hmmCount; h1++)
	{
		anc_score_win[h1] = (double*)calloc(hmmCount,sizeof(double));
		anc_score[h1] = (double*)calloc(hmmCount,sizeof(double));
	}
	anc1_call = (int**)calloc(nr_samples,sizeof(int*));
	anc2_call = (int**)calloc(nr_samples,sizeof(int*));
	for(int i =0; i < nr_samples;i++)
	{
		anc1_call[i] = (int*)calloc(nr_hsnp,sizeof(int));
		anc2_call[i] = (int*)calloc(nr_hsnp,sizeof(int));
		for(int j = 0; j < totalSNPSize; j++)
		{
			anc1_call[i][j] = -1;
			anc2_call[i][j] = -1;
		}
	}
	for(int i = 0; i < nr_samples; i++)
	{
		for(int j =0; j < totalSNPSize; j++)
			for(int h1 = 0; h1 < hmmCount; h1++)
				for(int h2 = h1; h2 < hmmCount; h2++)
				{
					probMatrix[j][h1][h2]=0;
				}
		for(int h1 = 0; h1 < hmmCount; h1++)
			for(int h2 = h1; h2 < hmmCount; h2++)
				for(int j =1; j <= totalSNPSize; j++)
				{
					if (isFullMissingSNP(j)) //Imputation SNP should not affect ancestral inference
						probMatrix[j][h1][h2] = probMatrix[j-1][h1][h2];
					else 
					{
/*
						if((ap_0[h1][h2][i][j]<=0)&&(ap_1[h1][h2][i][j]<=0)&&(ap_2[h1][h2][i][j]<=0))
						{
							ap_tot = MIN_NR;
						}
						else
*/
							ap_tot = (ap_0[h1][h2][i][j-1] + ap_1[h1][h2][i][j-1] +ap_2[h1][h2][i][j-1]);

						prev_tot = probMatrix[j-1][h1][h2];
						a0Val = (ap_0[h1][h2][i][j-1] /ap_tot);
						if(a0Val <0) a0Val = 0;
						a1Val = (ap_1[h1][h2][i][j-1] /ap_tot);
						if(a1Val <0) a1Val = 0;
						a2Val = (ap_2[h1][h2][i][j-1] /ap_tot);
						if(a2Val <0) a2Val = 0;
						if(ap_tot == 0)
							probMatrix[j][h1][h2] = 0;
						else if(true_gen[i][j-1] == 0)
							probMatrix[j][h1][h2] = prev_tot + a0Val;
						else if(true_gen[i][j-1] == 1)
							probMatrix[j][h1][h2] = prev_tot + a1Val;
						else if(true_gen[i][j-1] == 2)
							probMatrix[j][h1][h2] = prev_tot + a2Val;
						else
						{
							probMatrix[j][h1][h2] = prev_tot + .33333;
//							fprintf(stderr,"error in true gen %d,i=%d,j=%d\n",true_gen[i][j-1],i,j-1);
//							exit(0);
						}
					}
			}
		for(int j =0; j < totalSNPSize; j++)
		{
			if (!isFullMissingSNP(j)) //Determine best ancestry for non-imputed SNPs 1st
			{
				for(int h1 = 0; h1 < hmmCount; h1++) 
					for(int h2 = h1; h2 < hmmCount; h2++)
						anc_score[h1][h2]=0;
				for(int win=100; win<=1500; win+=100)
				{
					int s=j-win;
					int e=j+win;
					if(s<0)
					{
						s=0;
					}
					if(e>totalSNPSize)
					{
						e=totalSNPSize;
					}
					for(int h1 = 0; h1 < hmmCount; h1++)
						for(int h2 = h1; h2 < hmmCount; h2++)
						{
							anc_score_win[h1][h2] = probMatrix[e][h1][h2]- probMatrix[s][h1][h2];
						}
					tot = 0;
					for(int h1 = 0; h1 < hmmCount; h1++)
						for(int h2 = h1; h2 < hmmCount; h2++)
						{
							tot+= anc_score_win[h1][h2];
//fprintf(stderr,"DEBUj=%d,tot=%e=anc_score_win[%d][%d]=%e\n",j,tot,h1,h2,anc_score_win[h1][h2]);
						}
					if(tot <= 0)
					{
						fprintf(stderr,"error in output files, sum of probs %f <=0\n",tot);
						exit(0);
					}
					for(int h1 = 0; h1 < hmmCount; h1++)
						for(int h2 = h1; h2 < hmmCount; h2++)
							anc_score_win[h1][h2] /= tot;
					for(int h1 = 0; h1 < hmmCount; h1++)
						for(int h2 = h1; h2 < hmmCount; h2++)
							anc_score[h1][h2] += anc_score_win[h1][h2];
				}//end for win
				int bestH1 = 0;
				int bestH2 = 0;
				for(int h1 = 0; h1 < hmmCount; h1++)
					for(int h2 = h1; h2 < hmmCount; h2++)
					{
						if(anc_score[h1][h2] > anc_score[bestH1][bestH2]) 
						{
							bestH1 = h1;
							bestH2 = h2;
						}
					}
				anc1_call[i][j] = bestH1;
				anc2_call[i][j] = bestH2;
			}
		}//end for j (nr_hsnp)
		for(int j =0; j < totalSNPSize; j++)
		{
			if (isFullMissingSNP(j)) //Imputation SNP ancestral inference should belong to adjacent SNP, 2nd pass
			{
				int loc;
				if(getNearestTypedDistanceBefore(j) < getNearestTypedDistanceAfter(j))
					loc = getNearestTypedLocBefore(j);
				else
					loc = getNearestTypedLocAfter(j);
				anc1_call[i][j] = anc1_call[i][loc];
				anc2_call[i][j] = anc2_call[i][loc];
			}
		}
	}//end for i (nr_samples)
/*
	for(int j =0; j < totalSNPSize+2; j++)
	{
		for(int h1 = 0; h1 < hmmCount; h1++)
			free(probMatrix[j][h1]);
		free(probMatrix[j]);
	}
	free(probMatrix);
	for(int h1 = 0; h1 < hmmCount; h1++)
	{
		free(anc_score_win[h1]);
		free(anc_score[h1]);
	}
	free(anc_score);
	free(anc_score_win);
	for(int i =0; i < nr_samples;i++)
	{
		free(anc1_call[i]);
		free(anc2_call[i]);
	}
	free(anc1_call);
	free(anc2_call);
	*/
//fprintf(
}
void outputEDC()
{
	fprintf(stderr,"Outputting Error Detection and Correction (EDC)\n");
	char sEDC_FileName [100];
	sprintf(sEDC_FileName,"%s.EDC",final_Output_file_name);
	FILE * fEDC = fopen(sEDC_FileName,"w");
	fprintf(fEDC,"rs#\tsampleID\tAnc1\tAnc2\tA0\tA1\tprob\n");
	int uniqCount = 0;
	double llrVal;
	char orgGen; 
	double totalVal;
	char bestGen;
	double bestVal;
	int h1,h2;
	char predA0,predA1;
	int currSNP;
	for(int i = 0;i < nr_samples; i++)
	{
		currSNP = 0;
		for(int j = 0; j < nr_hsnp; j++)
		{
			if(!snp_map[j].isXSNP)
			{
				orgGen = gen_to_est_array_full[i][currSNP];
				llrVal = -1;
				h1 = anc1_call[i][currSNP];
				h2 = anc2_call[i][currSNP];
				totalVal = log10(ap_0[h1][h2][i][currSNP] + ap_1[h1][h2][i][currSNP] + ap_2[h1][h2][i][currSNP]);
				if(orgGen == '0') llrVal = totalVal - log10(ap_0[h1][h2][i][currSNP]);
				else if(orgGen == '1') llrVal = totalVal - log10(totalVal/ap_1[h1][h2][i][currSNP]);
				else if(orgGen == '2') llrVal = totalVal - log10(totalVal/ap_2[h1][h2][i][currSNP]);
				if(llrVal >= llrt)
				{
					fprintf(fEDC,"%s\t%s\t%s\t%s",
						snp_map[j].id,
						ped_map[i].id,
						anc_map[h1].name,
						anc_map[h2].name);
					predA0 = snp_map[j].a0;
					predA1 = snp_map[j].a0;
					bestGen = '0';
					bestVal = ap_0[h1][h2][i][currSNP];
					if(ap_1[h1][h2][i][currSNP] > bestVal)
					{
						predA0 = snp_map[j].a1;
						predA1 = snp_map[j].a1;
						bestGen = '1';
						bestVal = ap_1[h1][h2][i][currSNP];
					}
					if(ap_2[h1][h2][i][currSNP] > bestVal)
					{
						predA0 = snp_map[j].a0;
						predA1 = snp_map[j].a1;
						bestGen = '2';
						bestVal = ap_2[h1][h2][i][currSNP];
					}
					fprintf(fEDC,"\t%c\t%c\t%e\n",predA0,predA1,bestVal/(ap_0[h1][h2][i][currSNP] + ap_1[h1][h2][i][currSNP] + ap_2[h1][h2][i][currSNP]));
					uniqCount++;
					gen_to_est_array_full[i][currSNP] = bestGen;
				}
				currSNP++;
			}//end if !XSNP
		}//end j loop
	}//end i loop
	fclose(fEDC);
	fprintf(stderr,"\ndiscovered %d error detection genotypes\n",uniqCount);
	FILE * fSummary = fopen("Summary.txt","a");
	fprintf(fSummary,"TOTAL NUMBER OF GENOTYPES DISCOVERED IN ERROR: %d\n",uniqCount);
	fclose(fSummary);
}
void outputMDR()
{
	fprintf(stderr,"Outputting Missing Data Recovery (MDR)\n");
	char sMDR_FileName [100];
	sprintf(sMDR_FileName,"%s.MDR",final_Output_file_name);
	FILE * fMDR = fopen(sMDR_FileName,"w");
	fprintf(fMDR,"rs#\tsampleID\tAnc1\tAnc2\tA0\tA1\tprob\n");
	int uniqCount = 0;
	char orgGen; 
	char bestGen;
	double bestVal;
	int h1,h2;
	char predA0,predA1;
	int currSNP;
	for(int i = 0;i < nr_samples; i++)
	{
		currSNP = 0;
		for(int j = 0; j < nr_hsnp; j++)
		{
			if(!snp_map[j].isXSNP)
			{			
				orgGen = gen_to_est_array_full[i][currSNP];
				if(
					((orgGen == '3')||(orgGen == '?')) &&
					(!isFullMissingSNP(currSNP))
					)
				{
					h1 = anc1_call[i][currSNP];
					h2 = anc2_call[i][currSNP];
					fprintf(fMDR,"%s\t%s\t%s\t%s",
						snp_map[j].id,
						ped_map[i].id,
						anc_map[h1].name,
						anc_map[h2].name);
					predA0 = snp_map[j].a0;
					predA1 = snp_map[j].a0;
					bestGen = '0';
					bestVal = ap_0[h1][h2][i][currSNP];
					if(ap_1[h1][h2][i][currSNP] > bestVal)
					{
						predA0 = snp_map[j].a1;
						predA1 = snp_map[j].a1;
						bestGen = '1';
						bestVal = ap_1[h1][h2][i][currSNP];
					}
					if(ap_2[h1][h2][i][currSNP] > bestVal)
					{
						predA0 = snp_map[j].a0;
						predA1 = snp_map[j].a1;
						bestGen = '2';
						bestVal = ap_2[h1][h2][i][currSNP];
					}
					fprintf(fMDR,"\t%c\t%c\t%e\n",predA0,predA1,bestVal/(ap_0[h1][h2][i][currSNP] + ap_1[h1][h2][i][currSNP] + ap_2[h1][h2][i][currSNP]));
					uniqCount++;
					gen_to_est_array_full[i][currSNP] = bestGen;
				}
				currSNP++;
			}
		}
	}
	fclose(fMDR);
	fprintf(stderr,"\ndiscovered %d missing genotypes\n",uniqCount);
	FILE * fSummary = fopen("Summary.txt","a");
	fprintf(fSummary,"TOTAL NUMBER OF MISSING GENOTYPES DISCOVERED: %d\n",uniqCount);
	fclose(fSummary);
}

void outputIMP()
{
	fprintf(stderr,"Outputting Imputation (IMP)\n");
	char sIMP_FileName [100];
	sprintf(sIMP_FileName,"%s.IMP",final_Output_file_name);
	FILE * fIMP = fopen(sIMP_FileName,"w");
	fprintf(fIMP,"rs#\tsampleID\tAnc1\tAnc2\tA0\tA1\tprob\n");
	int uniqCount = 0;
	char orgGen; 
	char bestGen;
	double bestVal;
	double postProb;
	int h1,h2;
	char predA0,predA1;
	int currSNP;
	for(int i = 0;i < nr_samples; i++)
	{
		currSNP = 0;
		for(int j = 0; j < nr_hsnp; j++)
		{
			if(!snp_map[j].isXSNP)
			{			
				orgGen = gen_to_est_array_full[i][currSNP];
				if(isFullMissingSNP(currSNP))
				{
					h1 = anc1_call[i][currSNP];
					h2 = anc2_call[i][currSNP];
					fprintf(fIMP,"%s\t%s\t%s\t%s",
						snp_map[j].id,
						ped_map[i].id,
						anc_map[h1].name,
						anc_map[h2].name);
					predA0 = snp_map[j].a0;
					predA1 = snp_map[j].a0;
					bestGen = '0';
					bestVal = ap_0[h1][h2][i][currSNP];
					if(ap_1[h1][h2][i][currSNP] > bestVal)
					{
						predA0 = snp_map[j].a1;
						predA1 = snp_map[j].a1;
						bestGen = '1';
						bestVal = ap_1[h1][h2][i][currSNP];
					}
					if(ap_2[h1][h2][i][currSNP] > bestVal)
					{
						predA0 = snp_map[j].a0;
						predA1 = snp_map[j].a1;
						bestGen = '2';
						bestVal = ap_2[h1][h2][i][currSNP];
					}
					postProb = bestVal/(ap_0[h1][h2][i][currSNP] + ap_1[h1][h2][i][currSNP] + ap_2[h1][h2][i][currSNP]);
					fprintf(fIMP,"\t%c\t%c\t%e\n",predA0,predA1,postProb);
					uniqCount++;
					gen_to_est_array_full[i][currSNP] = bestGen;
				}
				currSNP++;
			}
		}
	}
	fclose(fIMP);
	fprintf(stderr,"\nimputed %d genotypes\n",uniqCount);
	FILE * fSummary = fopen("Summary.txt","a");
	fprintf(fSummary,"TOTAL NUMBER OF GENOTYPES IMPUTED: %d\n",uniqCount);
	fclose(fSummary);
}
void outputAncestryInference()
{
	fprintf(stderr,"Outputting GEDI-ADMX results, including ancestry inference");
	char sANC_FileName [100];
	sprintf(sANC_FileName,"%s.ANC",final_Output_file_name);
	FILE * fFinalOutput = fopen(sANC_FileName,"w");
	fprintf(fFinalOutput,"rs#\tsampleID\tAnc1\tAnc2");
	if(bOutputProb)
	{
		fprintf(fFinalOutput,"\tA0\tA1\tG");
		for(int h1 =0; h1 < hmmCount; h1++)
			for(int h2 = h1; h2 < hmmCount; h2++)
			{
				fprintf(fFinalOutput,"\tP_0_%s_%s\tP_1_%s_%s\tP_2_%s_%s",anc_map[h1].name,anc_map[h2].name,anc_map[h1].name,anc_map[h2].name,anc_map[h1].name,anc_map[h2].name);		
			}
	}
	fprintf(fFinalOutput,"\n");
	int uniqCount = 0;
	int currSNP;
	char outGen;
	char inGen;
	for(int i = 0;i < nr_samples; i++)
	{
		currSNP = 0;
		for(int j = 0; j < nr_hsnp; j++)
		{
			if(!snp_map[j].isXSNP)
			{			
				fprintf(fFinalOutput,"%s\t%s\t%s\t%s",
					snp_map[j].id,
					ped_map[i].id,
					anc_map[anc1_call[i][currSNP]].name,
					anc_map[anc2_call[i][currSNP]].name);
				if(bOutputProb)
				{
					inGen = gen_to_est_array_full[i][currSNP];
					if(inGen == '1') outGen = '2';
					else if(inGen == '2') outGen = '1';
					else outGen = inGen;
					fprintf(fFinalOutput,"\t%c\t%c\t%c",snp_map[j].a0,snp_map[j].a1,outGen);
						for(int h1 =0; h1 < hmmCount; h1++)
							for(int h2 = h1; h2 < hmmCount; h2++)
							{
								fprintf(fFinalOutput,"\t%e\t%e\t%e",ap_0[h1][h2][i][currSNP],ap_2[h1][h2][i][currSNP],ap_1[h1][h2][i][currSNP]);
							}
				}
				fprintf(fFinalOutput,"\n");
				uniqCount++;
				currSNP++;
			}
			else
			{
			}
		}
	}
	fclose(fFinalOutput);
	fprintf(stderr,"\nprocessed %d genotypes\n",uniqCount);
	FILE * fSummary = fopen("Summary.txt","a");
	fprintf(fSummary,"TOTAL NUMBER OF GENOTYPES IN OUTPUT FILE: %d\n",uniqCount);
	fclose(fSummary);
}
int getEndLocGlobal()//scans for non-imputed snps from startLoc up to a total of blocksize non-imputed snps
{
	int currLocGlobal = startLocGlobal;
	int nonImpCount = 0;
	while((nonImpCount < blocksize)&&(currLocGlobal < totalSNPSize))
	{
		if(!isFullMissingSNP(currLocGlobal)) nonImpCount++;
		currLocGlobal++;
	}
	return currLocGlobal;
}
int getNr_snp()//scans # of non-imputed SNPs from startLoc to endLoc
{
	int nonImpCount = 0;
	for(int i = startLocGlobal; i < endLocGlobal; i++)
	{
		if(!isFullMissingSNP(i)) nonImpCount++;
	}
	return nonImpCount;
}
int getGlobalSNP(int localSNP)//starting at startLocGlobal, get the global index of localSNP
												//by adding imputed snps
{
	int currSNP = 0;
	int globalOffset = 0;
	while (
			((currSNP < localSNP)||isFullMissingSNP(startLocGlobal+globalOffset))&&
			(startLocGlobal+globalOffset < totalSNPSize)
			)
	{
		if((!isFullMissingSNP(startLocGlobal+globalOffset))) currSNP++;
		globalOffset++;
	}
	return startLocGlobal+globalOffset;
}
int getOverlapSize(int locGlobal)// scans back from locGlobal an amount of half_overlap # of non-imputed SNPs
{
	int currOverlap = 0;
	int currSize = 0;
	int currLocGlobal = locGlobal;
	while(currOverlap < half_overlap)
	{
		if(!isFullMissingSNP(currLocGlobal)) currOverlap++;
		currSize++;
		currLocGlobal--;
	}
	return currSize+1;
}
int getNearestTypedDistanceBefore(int baseLocGlobal)// scan back to find the distance to the nearest typed SNP before baseSNP
{
	int currLocGlobal = baseLocGlobal;
	bool bFound = false;
	while ((currLocGlobal > 0)&& !bFound)
	{
		currLocGlobal--;
		if(!isFullMissingSNP(currLocGlobal)) bFound = true;
	}
	if(!bFound) return 99999999; //Last resort if not found
	return snp_map[baseLocGlobal].pos - snp_map[currLocGlobal].pos;
}
int getNearestTypedLocBefore(int baseLocGlobal)// scan back to find the distance to the nearest typed SNP before baseSNP
{
	int currLocGlobal = baseLocGlobal;
	while (currLocGlobal > 0)
	{
		currLocGlobal--;
		if(!isFullMissingSNP(currLocGlobal)) return currLocGlobal;
	}
	return -1;
}
int getNearestTypedDistanceAfter(int baseLocGlobal)// scan back to find the distance to the nearest typed SNP before baseSNP
{
	int currLocGlobal = baseLocGlobal;
	bool bFound = false;
	while ((currLocGlobal < totalSNPSize)&& !bFound)
	{
		currLocGlobal++;
		if(!isFullMissingSNP(currLocGlobal)) bFound = true;
	}
	if(!bFound) return 99999999; //Last resort if not found
	return snp_map[currLocGlobal].pos - snp_map[baseLocGlobal].pos;
}
int getNearestTypedLocAfter(int baseLocGlobal)// scan back to find the distance to the nearest typed SNP before baseSNP
{
	int currLocGlobal = baseLocGlobal;
	while (currLocGlobal < totalSNPSize)
	{
		currLocGlobal++;
		if(!isFullMissingSNP(currLocGlobal)) return currLocGlobal;
	}
	return -1;
}
bool runPass1() //Admixed
{
	fprintf(stderr,"BEGIN PASS 1(Admixed probabilities)\n");
	initAncestryInference(); //stuff used for ancestry inference
	startLocGlobal = 0;
	blocknum = 1;
	endLocGlobal = getEndLocGlobal();
	while((startLocGlobal < (totalSNPSize - (half_overlap+1)))&&
		(endLocGlobal < totalSNPSize)
	)
	{
		endLocGlobal = getEndLocGlobal();
		nr_snp = getNr_snp();
		alloc_mem_other();
		gen_to_est_array = (char**)malloc(nr_gen_to_estimate*sizeof(char*));
		for(int i = 0; i < nr_gen_to_estimate; i++)
		{
			gen_to_est_array[i] = (char*)malloc((nr_snp)*sizeof(char));
			for(int j = 0; j < (nr_snp); j++)
			{
				gen_to_est_array[i][j] = gen_to_est_array_full[i][getGlobalSNP(j)];
			}
		}
		for(int h = 0; h < hmmCount; h++)
		{
			alloc_mem_hmm(&anc_map[h].hmm);
			anc_map[h].hap_array_ANC = (char**)malloc((2*anc_map[h].nr_genANC) * sizeof(char*));	
			for(int i = 0; i < anc_map[h].nr_genANC; i++)
			{
				anc_map[h].hap_array_ANC[2*i] = (char*)malloc((nr_snp)*sizeof(char));
				anc_map[h].hap_array_ANC[2*i+1] = (char*)malloc((nr_snp)*sizeof(char));
 				for(int j = 0; j < nr_snp; j++)
 				{
					anc_map[h].hap_array_ANC[2*i][j] = anc_map[h].hap_array_full_ANC[2*i][getGlobalSNP(j)];
					anc_map[h].hap_array_ANC[2*i+1][j] = anc_map[h].hap_array_full_ANC[2*i+1][getGlobalSNP(j)];
				} 
			}	
		}
		fprintf(stderr,"Admixed Calculations beginning at SNP %d...",(startLocGlobal + 1));

		double startTimeGEDI = (double)clock();
		for(int h = 0; h < hmmCount; h++)
		{
			trainHMM(h);
		}
		#if defined(_WIN32) || defined(_WIN64)
			fprintf(stderr," training %f sec, ",(((double)clock()-startTimeGEDI)/1000));
			trainingTime+= ((double)clock()-startTimeGEDI)/1000;
		#else
			fprintf(stderr," training %f sec, ",(((double)clock()-startTimeGEDI)/1000000));
			trainingTime+= ((double)clock()-startTimeGEDI)/1000000;
		#endif
		startTimeGEDI = (double)clock();
 		runGEDI();
		#if defined(_WIN32) || defined(_WIN64)
			fprintf(stderr," computations %f sec\n",(((double)clock()-startTimeGEDI)/1000));
		#else
			fprintf(stderr," computations %f sec\n",(((double)clock()-startTimeGEDI)/1000000));
		#endif
		free_mem_other();
		for(int i = 0; i < nr_gen_to_estimate; i++)
			free(gen_to_est_array[i]);
		free(gen_to_est_array);
		for(int h = 0; h < hmmCount; h++)
		{
			free_mem_hmm(&anc_map[h].hmm);
			for(int i = 0; i < anc_map[h].nr_genANC; i++)
			{
				free(anc_map[h].hap_array_ANC[2*i]);
				free(anc_map[h].hap_array_ANC[2*i+1]);
			}	
			free(anc_map[h].hap_array_ANC);
		}
 		startLocGlobal = endLocGlobal - getOverlapSize(endLocGlobal);
		blocknum++;
	}//end while loop
	fprintf(stderr,"END PASS 1\n");
	computeAncestryInference();
	return true;
}
void setMissingIndicators()
{
	bISFULLIMP = true;
	hasPartialMissingData = false;
	snp_missing_full = (bool*)malloc((totalSNPSize)*sizeof(bool));
	snp_missing_partial = (bool*)malloc((totalSNPSize)*sizeof(bool));
	snp_typed_full = (bool*)malloc((totalSNPSize)*sizeof(bool));
	snp_typed_partial = (bool*)malloc((totalSNPSize)*sizeof(bool));
	for(int j = 0; j < totalSNPSize; j++)
	{
		snp_missing_full[j] = true;
		snp_missing_partial[j] = false;
		snp_typed_full[j] = true;
		snp_typed_partial[j] = false;
	}
	for(int i = 0; i < nr_gen_to_estimate; i++)
	{
		for(int j = 0; j < totalSNPSize; j++)
		{
			if((gen_to_est_array_full[i][j] == '?')||(gen_to_est_array_full[i][j] == '3'))
			{
				snp_missing_partial[j] = true;
				snp_typed_full[j] = false;
			}
			else
			{
				bISFULLIMP = false;
				snp_missing_full[j] = false;
				snp_typed_partial[j] = true;
			}
		}
	}
	for(int j = 0; j < totalSNPSize; j++)
	{
		if((snp_missing_partial[j] == true)&&(snp_typed_partial[j] == true))
		{
			hasPartialMissingData = true;
			return;
		}
	}
}
void freeMissingIndicators()
{
	free(snp_missing_full);
	free(snp_missing_partial);
	free(snp_typed_full);
	free(snp_typed_partial);
}

void freeKData()
{
	for(int h = 0; h < hmmCount; h++)
	{
		free_mem_hmm(&anc_map[h].hmm);
		for(int i = 0; i < anc_map[h].nr_genANC; i++)
		{
			free(anc_map[h].hap_array_ANC[2*i]);
			free(anc_map[h].hap_array_ANC[2*i+1]);
		}	
		free(anc_map[h].hap_array_ANC);
	}
	for(int i = 0; i < nr_gen_to_estimate; i++)
	{
	 	free(gen_to_est_array[i]);
	}
	free(gen_to_est_array);
}
void setKData()
{
	int countBeforeK = 0; //This keeps track of how many genotypes are before K
	int currPos = currKSNPGlobal -1;
	while((countBeforeK < flanking)&&(currPos >= 0))
	{
		if(bISFULLIMP) countBeforeK++;
		else if(!isFullMissingSNP(currPos)) countBeforeK++;
		currPos--;
	}
	int currPosGlobalG = currPos+1;
	int currPosGlobalH = currPos+1;
	int countAfterK = 0; 
	currPos = currKSNPGlobal + 1;
	while((countAfterK < flanking)&&(currPos < (totalSNPSize)))
	{
		if(bISFULLIMP) countAfterK++;
		else if(!isFullMissingSNP(currPos)) countAfterK++;
		currPos++;
	}
	currKSNPLocal = countBeforeK;
	nr_snp = countBeforeK + countAfterK + 1;
	for(int h = 0; h < hmmCount; h++)
	{
		alloc_mem_hmm(&anc_map[h].hmm);
		anc_map[h].hap_array_ANC = (char**)malloc((2*anc_map[h].nr_genANC) * sizeof(char*));	
		for(int i = 0; i < anc_map[h].nr_genANC; i++)
		{
			anc_map[h].hap_array_ANC[2*i] = (char*)malloc((nr_snp + 1)*sizeof(char));
			anc_map[h].hap_array_ANC[2*i+1] = (char*)malloc((nr_snp + 1)*sizeof(char));
			int countMissing = 0;
			for(int j = 0; j < nr_snp; j++)
	 		{
				if((j == currKSNPLocal)||(bISFULLIMP))
				{
					anc_map[h].hap_array_ANC[2*i][j] = anc_map[h].hap_array_full_ANC[2*i][currKSNPGlobal];
					anc_map[h].hap_array_ANC[2*i+1][j] = anc_map[h].hap_array_full_ANC[2*i+1][currKSNPGlobal];
				}
				else if(isFullMissingSNP(currPosGlobalH))
				{
					j--; //don't increment anything, because we want to skip untyped SNPs that are not k
					countMissing++;
				}
				else
				{
					anc_map[h].hap_array_ANC[2*i][j] = anc_map[h].hap_array_full_ANC[2*i][currPosGlobalH];
					anc_map[h].hap_array_ANC[2*i+1][j] = anc_map[h].hap_array_full_ANC[2*i+1][currPosGlobalH];
				}
				currPosGlobalH++;
			} 
			if((currPosGlobalH != currPos)&&(currPos != totalSNPSize))
			{
				fprintf(stderr,"last position in k-window %d VS %d do not match\n",currPosGlobalH, currPos);
				exit(0);
			}
			currPosGlobalH-= (nr_snp + countMissing);
		}	
	}
	gen_to_est_array = (char**)malloc(nr_gen_to_estimate*sizeof(char*));
	for(int i = 0; i < nr_gen_to_estimate; i++)
	{
	 	gen_to_est_array[i] = (char*)malloc(nr_snp*sizeof(char));
		int countMissing = 0;
	 	for(int j = 0; j < nr_snp; j++)
	 	{
			if((j == currKSNPLocal)||(bISFULLIMP))
			{
				gen_to_est_array[i][j] = gen_to_est_array_full[i][currKSNPGlobal]; //Should be missing
			}
			else if(isFullMissingSNP(currPosGlobalG))
			{
				j--; //don't increment anything, because we want to skip untyped SNPs that are not k
				countMissing++;
			}
			else
			{
				gen_to_est_array[i][j] = gen_to_est_array_full[i][currPosGlobalG];
			}
			currPosGlobalG++;
		} 
		if((currPosGlobalG != currPos)&&(currPos != totalSNPSize))
		{
			fprintf(stderr,"last position in k-window %d VS %d do not match\n",currPosGlobalG, currPos);
			exit(0);
		}
		currPosGlobalG-= (nr_snp + countMissing);
	}
//	half_overlap = 0;
}
bool isFullMissingSNP(int iSNPIndex)
{
	if(snp_missing_full[iSNPIndex]) return true;
	else return false;
}
int getNextKLoc()
{
	if(flanking <= 0) return -1;
	int currGlobal = currKSNPGlobal+1;
	while(currGlobal < totalSNPSize)
	{
		if(isFullMissingSNP(currGlobal)) return currGlobal;
		else currGlobal++;
	}
	return -1;
}

